Statistics
| Branch: | Tag: | Revision:

root / Makefile.am @ 46118ed2

History | View | Annotate | Download (47.8 kB)

1 e8230860 Michael Hanselmann
# Ganeti makefile
2 e8230860 Michael Hanselmann
# - Indent with tabs only.
3 e8230860 Michael Hanselmann
# - Keep files sorted; one line per file.
4 e8230860 Michael Hanselmann
# - Directories in lib/ must have their own *dir variable (see hypervisor).
5 e8230860 Michael Hanselmann
# - All directories must be listed DIRS.
6 0a7bed64 Michael Hanselmann
# - Use autogen.sh to generate Makefile.in and configure script.
7 e8230860 Michael Hanselmann
8 e8230860 Michael Hanselmann
# Automake doesn't export these variables before version 1.10.
9 e8230860 Michael Hanselmann
abs_top_builddir = @abs_top_builddir@
10 e8230860 Michael Hanselmann
abs_top_srcdir = @abs_top_srcdir@
11 e8230860 Michael Hanselmann
12 08366664 Michael Hanselmann
# Helper values for calling builtin functions
13 08366664 Michael Hanselmann
empty :=
14 08366664 Michael Hanselmann
space := $(empty) $(empty)
15 08366664 Michael Hanselmann
comma := ,
16 08366664 Michael Hanselmann
17 a01dd3c6 Iustin Pop
# Use bash in order to be able to use pipefail
18 a01dd3c6 Iustin Pop
SHELL=/bin/bash
19 a01dd3c6 Iustin Pop
20 6e06b36c Iustin Pop
ACLOCAL_AMFLAGS = -I autotools
21 4f3d5b76 Michael Hanselmann
BUILD_BASH_COMPLETION = $(top_srcdir)/autotools/build-bash-completion
22 b959138f Michael Hanselmann
RUN_IN_TEMPDIR = $(top_srcdir)/autotools/run-in-tempdir
23 eed5c5df Michael Hanselmann
CHECK_PYTHON_CODE = $(top_srcdir)/autotools/check-python-code
24 5d3c30df Michael Hanselmann
CHECK_HEADER = $(top_srcdir)/autotools/check-header
25 c55cc346 Iustin Pop
CHECK_MAN_DASHES = $(top_srcdir)/autotools/check-man-dashes
26 73d0e218 Iustin Pop
CHECK_MAN_WARNINGS = $(top_srcdir)/autotools/check-man-warnings
27 96602be4 Michael Hanselmann
CHECK_VERSION = $(top_srcdir)/autotools/check-version
28 7385c51d Michael Hanselmann
CHECK_NEWS = $(top_srcdir)/autotools/check-news
29 f6cbcc06 Michael Hanselmann
CHECK_IMPORTS = $(top_srcdir)/autotools/check-imports
30 95eb4188 Michael Hanselmann
DOCPP = $(top_srcdir)/autotools/docpp
31 e8230860 Michael Hanselmann
REPLACE_VARS_SED = autotools/replace_vars.sed
32 d99d1e36 Iustin Pop
CONVERT_CONSTANTS = $(top_srcdir)/autotools/convert-constants
33 d5a2a550 Michael Hanselmann
BUILD_RPC = $(top_srcdir)/autotools/build-rpc
34 6e3bf290 Michael Hanselmann
SHELL_ENV_INIT = autotools/shell-env-init
35 e8230860 Michael Hanselmann
36 22c5390d Iustin Pop
# Note: these are automake-specific variables, and must be named after
37 22c5390d Iustin Pop
# the directory + 'dir' suffix
38 2d48a3a2 Michael Hanselmann
clientdir = $(pkgpythondir)/client
39 e8230860 Michael Hanselmann
hypervisordir = $(pkgpythondir)/hypervisor
40 ff9efc03 Michael Hanselmann
httpdir = $(pkgpythondir)/http
41 dc101ecc Michael Hanselmann
masterddir = $(pkgpythondir)/masterd
42 12426ae1 Guido Trotter
confddir = $(pkgpythondir)/confd
43 8c229cc7 Oleksiy Mishchenko
rapidir = $(pkgpythondir)/rapi
44 899c4d2c Michael Hanselmann
serverdir = $(pkgpythondir)/server
45 9f4bb951 Michael Hanselmann
watcherdir = $(pkgpythondir)/watcher
46 bb44b1ae Michael Hanselmann
impexpddir = $(pkgpythondir)/impexpd
47 c047a981 Michael Hanselmann
utilsdir = $(pkgpythondir)/utils
48 e8230860 Michael Hanselmann
toolsdir = $(pkglibdir)/tools
49 7617fd6b Iustin Pop
iallocatorsdir = $(pkglibdir)/iallocators
50 0d2bf835 René Nussbaumer
pytoolsdir = $(pkgpythondir)/tools
51 e8230860 Michael Hanselmann
docdir = $(datadir)/doc/$(PACKAGE)
52 b8fe7ca6 Iustin Pop
myexeclibdir = $(pkglibdir)
53 e8230860 Michael Hanselmann
54 a4f12da4 Michael Hanselmann
# Delete output file if an error occurred while building it
55 a4f12da4 Michael Hanselmann
.DELETE_ON_ERROR:
56 a4f12da4 Michael Hanselmann
57 d5506465 Iustin Pop
HTOOLS_DIRS = \
58 d5506465 Iustin Pop
	htools \
59 d5506465 Iustin Pop
	htools/Ganeti \
60 358a0a8f Iustin Pop
	htools/Ganeti/Confd \
61 458a286a Iustin Pop
	htools/Ganeti/HTools \
62 4cbe9bda Iustin Pop
	htools/Ganeti/HTools/Program \
63 f0f3a6df Iustin Pop
	htools/Ganeti/Query \
64 e5a29b6c Iustin Pop
	htest \
65 e5a29b6c Iustin Pop
	htest/Test \
66 2733df51 Iustin Pop
	htest/Test/Ganeti \
67 aed2325f Iustin Pop
	htest/Test/Ganeti/Confd \
68 e1ee7d5a Iustin Pop
	htest/Test/Ganeti/HTools \
69 aed2325f Iustin Pop
	htest/Test/Ganeti/Query
70 d5506465 Iustin Pop
71 e8230860 Michael Hanselmann
DIRS = \
72 dad26941 Iustin Pop
	$(HTOOLS_DIRS) \
73 e8230860 Michael Hanselmann
	autotools \
74 e8230860 Michael Hanselmann
	daemons \
75 e8230860 Michael Hanselmann
	devel \
76 e8230860 Michael Hanselmann
	doc \
77 e8230860 Michael Hanselmann
	doc/examples \
78 c51580b3 Guido Trotter
	doc/examples/gnt-debug \
79 dad26941 Iustin Pop
	doc/examples/hooks \
80 dad26941 Iustin Pop
	htest/data \
81 dad26941 Iustin Pop
	htest/data/rapi \
82 dad26941 Iustin Pop
	htest/shelltests \
83 e8230860 Michael Hanselmann
	lib \
84 f9897b6d Michael Hanselmann
	lib/build \
85 dad26941 Iustin Pop
	lib/client \
86 2f16ea8f Michael Hanselmann
	lib/confd \
87 ff9efc03 Michael Hanselmann
	lib/http \
88 e8230860 Michael Hanselmann
	lib/hypervisor \
89 bb44b1ae Michael Hanselmann
	lib/impexpd \
90 dc101ecc Michael Hanselmann
	lib/masterd \
91 8c229cc7 Oleksiy Mishchenko
	lib/rapi \
92 899c4d2c Michael Hanselmann
	lib/server \
93 0d2bf835 René Nussbaumer
	lib/tools \
94 c047a981 Michael Hanselmann
	lib/utils \
95 9f4bb951 Michael Hanselmann
	lib/watcher \
96 e8230860 Michael Hanselmann
	man \
97 e8230860 Michael Hanselmann
	qa \
98 e8230860 Michael Hanselmann
	test \
99 e8230860 Michael Hanselmann
	test/data \
100 1e6fab60 Agata Murawska
	test/data/ovfdata \
101 d92518d3 Agata Murawska
	test/data/ovfdata/other \
102 e8230860 Michael Hanselmann
	tools
103 e8230860 Michael Hanselmann
104 2750b299 Michael Hanselmann
BUILDTIME_DIR_AUTOCREATE = \
105 c964d962 Michael Hanselmann
	scripts \
106 22c5390d Iustin Pop
	$(APIDOC_DIR) \
107 22c5390d Iustin Pop
	$(APIDOC_HS_DIR) \
108 358a0a8f Iustin Pop
	$(APIDOC_HS_DIR)/Ganeti \
109 358a0a8f Iustin Pop
	$(APIDOC_HS_DIR)/Ganeti/Confd \
110 358a0a8f Iustin Pop
	$(APIDOC_HS_DIR)/Ganeti/HTools \
111 458a286a Iustin Pop
	$(APIDOC_HS_DIR)/Ganeti/HTools/Program \
112 662de722 Iustin Pop
	$(APIDOC_HS_DIR)/Ganeti/Query \
113 dad26941 Iustin Pop
	$(APIDOC_PY_DIR) \
114 22c5390d Iustin Pop
	$(COVERAGE_DIR) \
115 22c5390d Iustin Pop
	$(COVERAGE_HS_DIR) \
116 dad26941 Iustin Pop
	$(COVERAGE_PY_DIR) \
117 b91e9518 Iustin Pop
	.hpc
118 2750b299 Michael Hanselmann
119 2750b299 Michael Hanselmann
BUILDTIME_DIRS = \
120 2750b299 Michael Hanselmann
	$(BUILDTIME_DIR_AUTOCREATE) \
121 6b997854 Michael Hanselmann
	doc/html
122 6b997854 Michael Hanselmann
123 6b997854 Michael Hanselmann
DIRCHECK_EXCLUDE = \
124 6b997854 Michael Hanselmann
	$(BUILDTIME_DIRS) \
125 6b997854 Michael Hanselmann
	ganeti-[0-9]*.[0-9]*.[0-9]* \
126 6b997854 Michael Hanselmann
	doc/html/_*
127 6b997854 Michael Hanselmann
128 22c5390d Iustin Pop
# some helper vars
129 22c5390d Iustin Pop
COVERAGE_DIR = doc/coverage
130 22c5390d Iustin Pop
COVERAGE_PY_DIR = $(COVERAGE_DIR)/py
131 22c5390d Iustin Pop
COVERAGE_HS_DIR = $(COVERAGE_DIR)/hs
132 22c5390d Iustin Pop
APIDOC_DIR = doc/api
133 22c5390d Iustin Pop
APIDOC_PY_DIR = $(APIDOC_DIR)/py
134 22c5390d Iustin Pop
APIDOC_HS_DIR = $(APIDOC_DIR)/hs
135 22c5390d Iustin Pop
136 2ab2b9f5 Iustin Pop
MAINTAINERCLEANFILES = \
137 d17e74b4 Iustin Pop
	$(docpng) \
138 b76aac08 Michael Hanselmann
	$(maninput) \
139 cbf3d64b Michael Hanselmann
	doc/install-quick.rst \
140 84a12e40 Iustin Pop
	doc/news.rst \
141 7a03d293 Michael Hanselmann
	doc/upgrade.rst \
142 84a12e40 Iustin Pop
	vcs-version
143 2ab2b9f5 Iustin Pop
144 d17e74b4 Iustin Pop
maintainer-clean-local:
145 6b997854 Michael Hanselmann
	rm -rf $(BUILDTIME_DIRS)
146 d17e74b4 Iustin Pop
147 e8230860 Michael Hanselmann
CLEANFILES = \
148 2f16ea8f Michael Hanselmann
	$(addsuffix /*.py[co],$(DIRS)) \
149 d5506465 Iustin Pop
	$(addsuffix /*.hi,$(HTOOLS_DIRS)) \
150 d5506465 Iustin Pop
	$(addsuffix /*.o,$(HTOOLS_DIRS)) \
151 2d48a3a2 Michael Hanselmann
	$(PYTHON_BOOTSTRAP) \
152 f774bd03 Michael Hanselmann
	epydoc.conf \
153 5098afd1 Iustin Pop
	$(REPLACE_VARS_SED) \
154 6e3bf290 Michael Hanselmann
	$(SHELL_ENV_INIT) \
155 f154a7a3 Michael Hanselmann
	daemons/daemon-util \
156 fc3fd894 Michael Hanselmann
	daemons/ganeti-cleaner \
157 e8230860 Michael Hanselmann
	devel/upload \
158 656a7fdf Iustin Pop
	$(BUILT_EXAMPLES) \
159 f72f8622 Iustin Pop
	doc/examples/bash_completion \
160 e80aeb89 Michael Hanselmann
	doc/examples/bash_completion-debug \
161 d5a2a550 Michael Hanselmann
	lib/_generated_rpc.py \
162 2ab2b9f5 Iustin Pop
	$(man_MANS) \
163 2ab2b9f5 Iustin Pop
	$(manhtml) \
164 26916aad Apollon Oikonomopoulos
	tools/kvm-ifup \
165 e5afb848 Michael Hanselmann
	tools/vcluster-setup \
166 3735787e Iustin Pop
	stamp-directories \
167 dd1dfd9a Michael Hanselmann
	stamp-srclinks \
168 d6159933 Iustin Pop
	$(nodist_pkgpython_PYTHON) \
169 c3f67183 Iustin Pop
	$(HS_ALL_PROGS) $(HS_BUILT_SRCS) \
170 3096524e Iustin Pop
	$(HS_BUILT_TEST_HELPERS) \
171 b0dcdc10 Iustin Pop
	htools/ganeti-confd \
172 f0f3a6df Iustin Pop
	.hpc/*.mix htools/*.tix htest/*.tix \
173 191ff68c Iustin Pop
	doc/hs-lint.html
174 e8230860 Michael Hanselmann
175 4c3d5fb6 Iustin Pop
GENERATED_FILES = \
176 5098afd1 Iustin Pop
	$(built_base_sources) \
177 96a7481d Michael Hanselmann
	$(BUILT_PYTHON_SOURCES) \
178 96a7481d Michael Hanselmann
	$(PYTHON_BOOTSTRAP)
179 96a7481d Michael Hanselmann
180 ada0e680 Iustin Pop
HTOOLS_GENERATED_FILES =
181 ada0e680 Iustin Pop
if WANT_HTOOLS
182 ada0e680 Iustin Pop
HTOOLS_GENERATED_FILES += $(HS_PROGS)
183 04520998 Iustin Pop
if ENABLE_CONFD
184 f8d01158 Iustin Pop
HTOOLS_GENERATED_FILES += htools/hconfd htools/ganeti-confd
185 ada0e680 Iustin Pop
endif
186 ada0e680 Iustin Pop
endif
187 ada0e680 Iustin Pop
188 96a7481d Michael Hanselmann
built_base_sources = \
189 3735787e Iustin Pop
	stamp-directories \
190 3735787e Iustin Pop
	stamp-srclinks
191 2d1f248e Michael Hanselmann
192 96a7481d Michael Hanselmann
built_python_base_sources = \
193 13aeae6a Iustin Pop
	lib/_autoconf.py \
194 96a7481d Michael Hanselmann
	lib/_vcsversion.py
195 96a7481d Michael Hanselmann
196 96a7481d Michael Hanselmann
BUILT_PYTHON_SOURCES = \
197 96a7481d Michael Hanselmann
	$(built_python_base_sources) \
198 d5a2a550 Michael Hanselmann
	lib/_generated_rpc.py
199 e8230860 Michael Hanselmann
200 5098afd1 Iustin Pop
# Generating the RPC wrappers depends on many things, so make sure
201 5098afd1 Iustin Pop
# it's built at the end of the built sources
202 96a7481d Michael Hanselmann
lib/_generated_rpc.py: | $(built_base_sources) $(built_python_base_sources)
203 96a7481d Michael Hanselmann
204 656a7fdf Iustin Pop
# these are all built from the underlying %.in sources
205 656a7fdf Iustin Pop
BUILT_EXAMPLES = \
206 656a7fdf Iustin Pop
	doc/examples/ganeti-kvm-poweroff.initd \
207 656a7fdf Iustin Pop
	doc/examples/ganeti.cron \
208 656a7fdf Iustin Pop
	doc/examples/ganeti.initd \
209 656a7fdf Iustin Pop
	doc/examples/gnt-config-backup \
210 656a7fdf Iustin Pop
	doc/examples/hooks/ipsec
211 656a7fdf Iustin Pop
212 08366664 Michael Hanselmann
nodist_pkgpython_PYTHON = \
213 08366664 Michael Hanselmann
	$(BUILT_PYTHON_SOURCES)
214 08366664 Michael Hanselmann
215 f9897b6d Michael Hanselmann
noinst_PYTHON = \
216 5f43f393 Michael Hanselmann
	lib/build/__init__.py \
217 dad26941 Iustin Pop
	lib/build/shell_example_lexer.py \
218 dad26941 Iustin Pop
	lib/build/sphinx_ext.py
219 f9897b6d Michael Hanselmann
220 e8230860 Michael Hanselmann
pkgpython_PYTHON = \
221 e8230860 Michael Hanselmann
	lib/__init__.py \
222 a8a76bc2 Guido Trotter
	lib/asyncnotifier.py \
223 e8230860 Michael Hanselmann
	lib/backend.py \
224 e8230860 Michael Hanselmann
	lib/bdev.py \
225 e8230860 Michael Hanselmann
	lib/bootstrap.py \
226 e8230860 Michael Hanselmann
	lib/cli.py \
227 e8230860 Michael Hanselmann
	lib/cmdlib.py \
228 cea881e5 Michael Hanselmann
	lib/compat.py \
229 e8230860 Michael Hanselmann
	lib/config.py \
230 e8230860 Michael Hanselmann
	lib/constants.py \
231 821d9e43 Michael Hanselmann
	lib/daemon.py \
232 e8230860 Michael Hanselmann
	lib/errors.py \
233 62e0e880 Iustin Pop
	lib/ht.py \
234 e8230860 Michael Hanselmann
	lib/jqueue.py \
235 8b537bb0 Michael Hanselmann
	lib/jstore.py \
236 e8230860 Michael Hanselmann
	lib/locking.py \
237 e8230860 Michael Hanselmann
	lib/luxi.py \
238 e8230860 Michael Hanselmann
	lib/mcpu.py \
239 a744b676 Manuel Franceschini
	lib/netutils.py \
240 e8230860 Michael Hanselmann
	lib/objects.py \
241 32683096 René Nussbaumer
	lib/objectutils.py \
242 e8230860 Michael Hanselmann
	lib/opcodes.py \
243 ced78a66 Agata Murawska
	lib/ovf.py \
244 3329f4de Michael Hanselmann
	lib/pathutils.py \
245 a123dc19 Michael Hanselmann
	lib/qlang.py \
246 4ca96421 Michael Hanselmann
	lib/query.py \
247 e8230860 Michael Hanselmann
	lib/rpc.py \
248 6648cb36 Michael Hanselmann
	lib/rpc_defs.py \
249 f12e1736 René Nussbaumer
	lib/runtime.py \
250 e8230860 Michael Hanselmann
	lib/serializer.py \
251 e8230860 Michael Hanselmann
	lib/ssconf.py \
252 e8230860 Michael Hanselmann
	lib/ssh.py \
253 ac2d0fe4 Michael Hanselmann
	lib/storage.py \
254 1338f2b4 Balazs Lecz
	lib/uidpool.py \
255 05e733b4 Michael Hanselmann
	lib/vcluster.py \
256 76094e37 Michael Hanselmann
	lib/workerpool.py
257 e8230860 Michael Hanselmann
258 2d48a3a2 Michael Hanselmann
client_PYTHON = \
259 c2855a12 Michael Hanselmann
	lib/client/__init__.py \
260 02266fe0 Michael Hanselmann
	lib/client/gnt_backup.py \
261 7b3e7d41 Michael Hanselmann
	lib/client/gnt_cluster.py \
262 6d50f5f9 Michael Hanselmann
	lib/client/gnt_debug.py \
263 667dbd6b Adeodato Simo
	lib/client/gnt_group.py \
264 e792102d Michael Hanselmann
	lib/client/gnt_instance.py \
265 a09b9e3d Michael Hanselmann
	lib/client/gnt_job.py \
266 37494fa4 Michael Hanselmann
	lib/client/gnt_node.py \
267 6d50f5f9 Michael Hanselmann
	lib/client/gnt_os.py
268 2d48a3a2 Michael Hanselmann
269 e8230860 Michael Hanselmann
hypervisor_PYTHON = \
270 e8230860 Michael Hanselmann
	lib/hypervisor/__init__.py \
271 e8230860 Michael Hanselmann
	lib/hypervisor/hv_base.py \
272 48297fa2 Iustin Pop
	lib/hypervisor/hv_chroot.py \
273 e8230860 Michael Hanselmann
	lib/hypervisor/hv_fake.py \
274 eb58f9b1 Guido Trotter
	lib/hypervisor/hv_kvm.py \
275 4b5e40a5 Iustin Pop
	lib/hypervisor/hv_lxc.py \
276 e8230860 Michael Hanselmann
	lib/hypervisor/hv_xen.py
277 e8230860 Michael Hanselmann
278 8c229cc7 Oleksiy Mishchenko
rapi_PYTHON = \
279 8c229cc7 Oleksiy Mishchenko
	lib/rapi/__init__.py \
280 10b207d4 Oleksiy Mishchenko
	lib/rapi/baserlib.py \
281 95ab4de9 David Knowles
	lib/rapi/client.py \
282 20b509de Michael Hanselmann
	lib/rapi/client_utils.py \
283 10b207d4 Oleksiy Mishchenko
	lib/rapi/connector.py \
284 a85f23fa Michael Hanselmann
	lib/rapi/rlib2.py \
285 a85f23fa Michael Hanselmann
	lib/rapi/testutils.py
286 8c229cc7 Oleksiy Mishchenko
287 ff9efc03 Michael Hanselmann
http_PYTHON = \
288 02cab3e7 Michael Hanselmann
	lib/http/__init__.py \
289 be500c29 Michael Hanselmann
	lib/http/auth.py \
290 02cab3e7 Michael Hanselmann
	lib/http/client.py \
291 02cab3e7 Michael Hanselmann
	lib/http/server.py
292 ff9efc03 Michael Hanselmann
293 12426ae1 Guido Trotter
confd_PYTHON = \
294 71f27d19 Guido Trotter
	lib/confd/__init__.py \
295 b0dcdc10 Iustin Pop
	lib/confd/client.py
296 8c229cc7 Oleksiy Mishchenko
297 dc101ecc Michael Hanselmann
masterd_PYTHON = \
298 033a1d00 Michael Hanselmann
	lib/masterd/__init__.py \
299 0fcd0cad René Nussbaumer
	lib/masterd/iallocator.py \
300 033a1d00 Michael Hanselmann
	lib/masterd/instance.py
301 dc101ecc Michael Hanselmann
302 bb44b1ae Michael Hanselmann
impexpd_PYTHON = \
303 bb44b1ae Michael Hanselmann
	lib/impexpd/__init__.py
304 bb44b1ae Michael Hanselmann
305 9f4bb951 Michael Hanselmann
watcher_PYTHON = \
306 9ca87fb3 Michael Hanselmann
	lib/watcher/__init__.py \
307 adf6301e Michael Hanselmann
	lib/watcher/nodemaint.py \
308 adf6301e Michael Hanselmann
	lib/watcher/state.py
309 9f4bb951 Michael Hanselmann
310 899c4d2c Michael Hanselmann
server_PYTHON = \
311 29d91329 Michael Hanselmann
	lib/server/__init__.py \
312 5119f2ec Michael Hanselmann
	lib/server/masterd.py \
313 d9c82a4e Michael Hanselmann
	lib/server/noded.py \
314 d9c82a4e Michael Hanselmann
	lib/server/rapi.py
315 899c4d2c Michael Hanselmann
316 0d2bf835 René Nussbaumer
pytools_PYTHON = \
317 0d2bf835 René Nussbaumer
	lib/tools/__init__.py \
318 0d2bf835 René Nussbaumer
	lib/tools/ensure_dirs.py
319 0d2bf835 René Nussbaumer
320 c047a981 Michael Hanselmann
utils_PYTHON = \
321 4fd029cf Michael Hanselmann
	lib/utils/__init__.py \
322 79d22269 Michael Hanselmann
	lib/utils/algo.py \
323 9d1b963f Michael Hanselmann
	lib/utils/filelock.py \
324 f21bb4b7 Michael Hanselmann
	lib/utils/hash.py \
325 3865ca48 Michael Hanselmann
	lib/utils/io.py \
326 1ae4c5a1 Michael Hanselmann
	lib/utils/log.py \
327 8dc76d54 Guido Trotter
	lib/utils/mlock.py \
328 17b97ab3 Michael Hanselmann
	lib/utils/nodesetup.py \
329 a4ccecf6 Michael Hanselmann
	lib/utils/process.py \
330 7fcffe27 Michael Hanselmann
	lib/utils/retry.py \
331 7831fc5f Michael Hanselmann
	lib/utils/text.py \
332 c50645c0 Michael Hanselmann
	lib/utils/wrapper.py \
333 c50645c0 Michael Hanselmann
	lib/utils/x509.py
334 c047a981 Michael Hanselmann
335 f05c99f3 Michael Hanselmann
docrst = \
336 ffa6869f Iustin Pop
	doc/admin.rst \
337 dad26941 Iustin Pop
	doc/cluster-merge.rst \
338 5c0c1eeb Iustin Pop
	doc/design-2.0.rst \
339 4f366caf Michael Hanselmann
	doc/design-2.1.rst \
340 e56bb0e8 Guido Trotter
	doc/design-2.2.rst \
341 1eb85930 Guido Trotter
	doc/design-2.3.rst \
342 78b40c5e Michael Hanselmann
	doc/design-2.4.rst \
343 d774ce92 Michael Hanselmann
	doc/design-2.5.rst \
344 dad26941 Iustin Pop
	doc/design-autorepair.rst \
345 dad26941 Iustin Pop
	doc/design-bulk-create.rst \
346 dad26941 Iustin Pop
	doc/design-chained-jobs.rst \
347 ae9b5e0f Tsachy Shacham
	doc/design-cpu-pinning.rst \
348 dad26941 Iustin Pop
	doc/design-draft.rst \
349 dad26941 Iustin Pop
	doc/design-htools-2.3.rst \
350 278ddaa9 Michael Hanselmann
	doc/design-http-server.rst \
351 1375e1d9 Michael Hanselmann
	doc/design-impexp2.rst \
352 ed9fda24 Michael Hanselmann
	doc/design-lu-generated-jobs.rst \
353 4055b109 Adeodato Simo
	doc/design-multi-reloc.rst \
354 eec83a95 Apollon Oikonomopoulos
	doc/design-network.rst \
355 dad26941 Iustin Pop
	doc/design-node-state-cache.rst \
356 dad26941 Iustin Pop
	doc/design-oob.rst \
357 64ea845e Michael Hanselmann
	doc/design-ovf-support.rst \
358 dad26941 Iustin Pop
	doc/design-partitioned.rst \
359 dad26941 Iustin Pop
	doc/design-query-splitting.rst \
360 dad26941 Iustin Pop
	doc/design-query2.rst \
361 d85f01e7 Iustin Pop
	doc/design-resource-model.rst \
362 a997cec5 Apollon Oikonomopoulos
	doc/design-shared-storage.rst \
363 6b898285 Iustin Pop
	doc/design-virtual-clusters.rst \
364 dad26941 Iustin Pop
	doc/design-x509-ca.rst \
365 62947ebb Michael Hanselmann
	doc/devnotes.rst \
366 e2078d28 Iustin Pop
	doc/glossary.rst \
367 4d6443f4 Iustin Pop
	doc/hooks.rst \
368 876860a3 Iustin Pop
	doc/iallocator.rst \
369 d17e74b4 Iustin Pop
	doc/index.rst \
370 cbf3d64b Michael Hanselmann
	doc/install-quick.rst \
371 28e15341 Iustin Pop
	doc/install.rst \
372 9725b53d Michael Hanselmann
	doc/locking.rst \
373 6bf273d5 Michael Hanselmann
	doc/move-instance.rst \
374 c71a1a3d Iustin Pop
	doc/news.rst \
375 a47dc554 René Nussbaumer
	doc/ovfconverter.rst \
376 6d81475c Iustin Pop
	doc/rapi.rst \
377 b76aac08 Michael Hanselmann
	doc/security.rst \
378 35dd762d Michael Hanselmann
	doc/upgrade.rst \
379 ab171697 Michael Hanselmann
	doc/virtual-cluster.rst \
380 c71a1a3d Iustin Pop
	doc/walkthrough.rst
381 f05c99f3 Michael Hanselmann
382 0985325d Iustin Pop
HS_PROGS = htools/htools
383 22e513e7 Agata Murawska
HS_BIN_ROLES = hbal hscan hspace hinfo hcheck
384 ada0e680 Iustin Pop
HS_HTOOLS_PROGS = $(HS_BIN_ROLES) hail
385 d6159933 Iustin Pop
386 f0f3a6df Iustin Pop
HS_ALL_PROGS = $(HS_PROGS) htest/test htest/hpc-htools htools/hconfd
387 c3f67183 Iustin Pop
HS_PROG_SRCS = $(patsubst %,%.hs,$(HS_ALL_PROGS))
388 189b51fa Iustin Pop
HS_BUILT_TEST_HELPERS = $(HS_BIN_ROLES:%=htest/%) htest/hail
389 3096524e Iustin Pop
390 74e60746 Iustin Pop
HFLAGS = -O -Wall -Werror -fwarn-monomorphism-restriction -fwarn-tabs -ihtools
391 74e60746 Iustin Pop
# extra flags that can be overriden on the command line (e.g. -Wwarn, etc.)
392 d6159933 Iustin Pop
HEXTRA =
393 f0f3a6df Iustin Pop
# internal extra flags (used for htest/test mainly)
394 c7ec3025 Iustin Pop
HEXTRA_INT =
395 b91e9518 Iustin Pop
# exclude options for coverage reports
396 9822b1dd Iustin Pop
HPCEXCL = --exclude Main \
397 98b33d0e Iustin Pop
	--exclude Ganeti.Constants \
398 9822b1dd Iustin Pop
	--exclude Ganeti.HTools.QC \
399 dad26941 Iustin Pop
	--exclude Ganeti.THH \
400 2997cb0a Iustin Pop
	--exclude Ganeti.Version \
401 2733df51 Iustin Pop
	--exclude Test.Ganeti.TestCommon \
402 e1ee7d5a Iustin Pop
	--exclude Test.Ganeti.TestHTools \
403 e1ee7d5a Iustin Pop
	--exclude Test.Ganeti.TestHelper \
404 b88fcdd0 Iustin Pop
	--exclude Test.Ganeti.TestImports \
405 51309138 Iustin Pop
	$(patsubst htools.%,--exclude Test.%,$(subst /,.,$(patsubst %.hs,%, $(HS_LIB_SRCS))))
406 d6159933 Iustin Pop
407 c3f67183 Iustin Pop
HS_LIB_SRCS = \
408 dad26941 Iustin Pop
	htools/Ganeti/BasicTypes.hs \
409 dad26941 Iustin Pop
	htools/Ganeti/Common.hs \
410 dad26941 Iustin Pop
	htools/Ganeti/Compat.hs \
411 dad26941 Iustin Pop
	htools/Ganeti/Confd.hs \
412 dad26941 Iustin Pop
	htools/Ganeti/Confd/Server.hs \
413 dad26941 Iustin Pop
	htools/Ganeti/Confd/Utils.hs \
414 dad26941 Iustin Pop
	htools/Ganeti/Config.hs \
415 dad26941 Iustin Pop
	htools/Ganeti/Daemon.hs \
416 d6159933 Iustin Pop
	htools/Ganeti/HTools/CLI.hs \
417 d6159933 Iustin Pop
	htools/Ganeti/HTools/Cluster.hs \
418 d6159933 Iustin Pop
	htools/Ganeti/HTools/Container.hs \
419 d6159933 Iustin Pop
	htools/Ganeti/HTools/ExtLoader.hs \
420 d6159933 Iustin Pop
	htools/Ganeti/HTools/Group.hs \
421 d6159933 Iustin Pop
	htools/Ganeti/HTools/IAlloc.hs \
422 d6159933 Iustin Pop
	htools/Ganeti/HTools/Instance.hs \
423 d6159933 Iustin Pop
	htools/Ganeti/HTools/Loader.hs \
424 d6159933 Iustin Pop
	htools/Ganeti/HTools/Luxi.hs \
425 d6159933 Iustin Pop
	htools/Ganeti/HTools/Node.hs \
426 d6159933 Iustin Pop
	htools/Ganeti/HTools/PeerMap.hs \
427 9f13be88 Iustin Pop
	htools/Ganeti/HTools/Program.hs \
428 458a286a Iustin Pop
	htools/Ganeti/HTools/Program/Hail.hs \
429 201b6c34 Iustin Pop
	htools/Ganeti/HTools/Program/Hbal.hs \
430 22e513e7 Agata Murawska
	htools/Ganeti/HTools/Program/Hcheck.hs \
431 2922d2c5 René Nussbaumer
	htools/Ganeti/HTools/Program/Hinfo.hs \
432 7b695a0d Iustin Pop
	htools/Ganeti/HTools/Program/Hscan.hs \
433 1494a4cc Iustin Pop
	htools/Ganeti/HTools/Program/Hspace.hs \
434 dad26941 Iustin Pop
	htools/Ganeti/HTools/Rapi.hs \
435 dad26941 Iustin Pop
	htools/Ganeti/HTools/Simu.hs \
436 dad26941 Iustin Pop
	htools/Ganeti/HTools/Text.hs \
437 dad26941 Iustin Pop
	htools/Ganeti/HTools/Types.hs \
438 21dc8694 Iustin Pop
	htools/Ganeti/Hash.hs \
439 f3baf5ef Iustin Pop
	htools/Ganeti/JSON.hs \
440 dad26941 Iustin Pop
	htools/Ganeti/Jobs.hs \
441 ba4e38e8 Iustin Pop
	htools/Ganeti/Logging.hs \
442 d6159933 Iustin Pop
	htools/Ganeti/Luxi.hs \
443 b1e81520 Iustin Pop
	htools/Ganeti/Objects.hs \
444 e9aaa3c6 Iustin Pop
	htools/Ganeti/OpCodes.hs \
445 9eeb0aa5 Michael Hanselmann
	htools/Ganeti/Path.hs \
446 046fe3f5 Iustin Pop
	htools/Ganeti/Query/Common.hs \
447 8a65c02b Iustin Pop
	htools/Ganeti/Query/Filter.hs \
448 40246fa0 Agata Murawska
	htools/Ganeti/Query/Group.hs \
449 4cab6703 Iustin Pop
	htools/Ganeti/Query/Language.hs \
450 046fe3f5 Iustin Pop
	htools/Ganeti/Query/Node.hs \
451 4cbe9bda Iustin Pop
	htools/Ganeti/Query/Query.hs \
452 4cab6703 Iustin Pop
	htools/Ganeti/Query/Server.hs \
453 046fe3f5 Iustin Pop
	htools/Ganeti/Query/Types.hs \
454 4cab6703 Iustin Pop
	htools/Ganeti/Rpc.hs \
455 7946c25d Iustin Pop
	htools/Ganeti/Runtime.hs \
456 aa3adf35 Iustin Pop
	htools/Ganeti/Ssconf.hs \
457 26d62e4c Iustin Pop
	htools/Ganeti/THH.hs \
458 26d62e4c Iustin Pop
	htools/Ganeti/Utils.hs
459 51309138 Iustin Pop
460 51309138 Iustin Pop
HS_TEST_SRCS = \
461 1493a93b Iustin Pop
	htest/Test/Ganeti/BasicTypes.hs \
462 51000365 Iustin Pop
	htest/Test/Ganeti/Common.hs \
463 305e174c Iustin Pop
	htest/Test/Ganeti/Confd/Utils.hs \
464 dad26941 Iustin Pop
	htest/Test/Ganeti/Daemon.hs \
465 e1ee7d5a Iustin Pop
	htest/Test/Ganeti/HTools/CLI.hs \
466 e1ee7d5a Iustin Pop
	htest/Test/Ganeti/HTools/Cluster.hs \
467 e1ee7d5a Iustin Pop
	htest/Test/Ganeti/HTools/Container.hs \
468 e1ee7d5a Iustin Pop
	htest/Test/Ganeti/HTools/Instance.hs \
469 e1ee7d5a Iustin Pop
	htest/Test/Ganeti/HTools/Loader.hs \
470 e1ee7d5a Iustin Pop
	htest/Test/Ganeti/HTools/Node.hs \
471 e1ee7d5a Iustin Pop
	htest/Test/Ganeti/HTools/PeerMap.hs \
472 e1ee7d5a Iustin Pop
	htest/Test/Ganeti/HTools/Simu.hs \
473 e1ee7d5a Iustin Pop
	htest/Test/Ganeti/HTools/Text.hs \
474 e1ee7d5a Iustin Pop
	htest/Test/Ganeti/HTools/Types.hs \
475 2d87bd0a Iustin Pop
	htest/Test/Ganeti/JSON.hs \
476 2d87bd0a Iustin Pop
	htest/Test/Ganeti/Jobs.hs \
477 aed2325f Iustin Pop
	htest/Test/Ganeti/Luxi.hs \
478 2733df51 Iustin Pop
	htest/Test/Ganeti/Objects.hs \
479 aed2325f Iustin Pop
	htest/Test/Ganeti/OpCodes.hs \
480 90171729 Iustin Pop
	htest/Test/Ganeti/Query/Filter.hs \
481 aed2325f Iustin Pop
	htest/Test/Ganeti/Query/Language.hs \
482 b9bdc10e Iustin Pop
	htest/Test/Ganeti/Query/Query.hs \
483 aed2325f Iustin Pop
	htest/Test/Ganeti/Rpc.hs \
484 e1ee7d5a Iustin Pop
	htest/Test/Ganeti/Ssconf.hs \
485 e1ee7d5a Iustin Pop
	htest/Test/Ganeti/TestCommon.hs \
486 e1ee7d5a Iustin Pop
	htest/Test/Ganeti/TestHTools.hs \
487 26d62e4c Iustin Pop
	htest/Test/Ganeti/TestHelper.hs \
488 26d62e4c Iustin Pop
	htest/Test/Ganeti/Utils.hs
489 e4cc4c11 Iustin Pop
490 51309138 Iustin Pop
HS_LIBTEST_SRCS = $(HS_LIB_SRCS) $(HS_TEST_SRCS)
491 d6159933 Iustin Pop
492 b88fcdd0 Iustin Pop
HS_BUILT_SRCS = \
493 b88fcdd0 Iustin Pop
	htest/Test/Ganeti/TestImports.hs \
494 b88fcdd0 Iustin Pop
	htools/Ganeti/Constants.hs \
495 2997cb0a Iustin Pop
	htools/Ganeti/Version.hs
496 c3f67183 Iustin Pop
HS_BUILT_SRCS_IN = $(patsubst %,%.in,$(HS_BUILT_SRCS))
497 d6159933 Iustin Pop
498 3735787e Iustin Pop
$(RUN_IN_TEMPDIR): | stamp-directories
499 c964d962 Michael Hanselmann
500 a2d917f3 Iustin Pop
# Note: we use here an order-only prerequisite, as the contents of
501 a2d917f3 Iustin Pop
# _autoconf.py are not actually influencing the html build output: it
502 a2d917f3 Iustin Pop
# has to exist in order for the sphinx module to be loaded
503 a2d917f3 Iustin Pop
# successfully, but we certainly don't want the docs to be rebuilt if
504 a2d917f3 Iustin Pop
# it changes
505 c964d962 Michael Hanselmann
doc/html/index.html: $(docrst) $(docpng) doc/conf.py configure.ac \
506 7142485a Iustin Pop
	$(RUN_IN_TEMPDIR) lib/build/sphinx_ext.py \
507 7142485a Iustin Pop
	lib/build/shell_example_lexer.py lib/opcodes.py lib/ht.py \
508 08366664 Michael Hanselmann
	| $(BUILT_PYTHON_SOURCES)
509 d17e74b4 Iustin Pop
	@test -n "$(SPHINX)" || \
510 d17e74b4 Iustin Pop
	    { echo 'sphinx-build' not found during configure; exit 1; }
511 2750b299 Michael Hanselmann
	@mkdir_p@ $(dir $@)
512 e7f6524c Michael Hanselmann
	PYTHONPATH=. $(RUN_IN_TEMPDIR) $(SPHINX) -q -W -b html \
513 13de7d59 Michael Hanselmann
	    -d . \
514 d17e74b4 Iustin Pop
	    -D version="$(VERSION_MAJOR).$(VERSION_MINOR)" \
515 d17e74b4 Iustin Pop
	    -D release="$(PACKAGE_VERSION)" \
516 13de7d59 Michael Hanselmann
	    $(abs_top_srcdir)/doc $(CURDIR)/doc/html
517 13de7d59 Michael Hanselmann
	rm -f doc/html/.buildinfo doc/html/objects.inv
518 13de7d59 Michael Hanselmann
	touch $@
519 13de7d59 Michael Hanselmann
520 c964d962 Michael Hanselmann
doc/html: doc/html/index.html
521 2ab2b9f5 Iustin Pop
522 cbf3d64b Michael Hanselmann
doc/install-quick.rst: INSTALL
523 b76aac08 Michael Hanselmann
doc/news.rst: NEWS
524 7a03d293 Michael Hanselmann
doc/upgrade.rst: UPGRADE
525 b76aac08 Michael Hanselmann
526 e8deef56 Michael Hanselmann
doc/install-quick.rst doc/news.rst doc/upgrade.rst:
527 cbf3d64b Michael Hanselmann
	set -e; \
528 cbf3d64b Michael Hanselmann
	{ echo '.. This file is automatically updated at build time from $<.'; \
529 cbf3d64b Michael Hanselmann
	  echo '.. Do not edit.'; \
530 cbf3d64b Michael Hanselmann
	  echo; \
531 cbf3d64b Michael Hanselmann
	  cat $<; \
532 cbf3d64b Michael Hanselmann
	} > $@
533 cbf3d64b Michael Hanselmann
534 b8195800 Iustin Pop
docdot = \
535 ca9ccea8 Michael Hanselmann
	doc/arch-2.0.dot \
536 ca9ccea8 Michael Hanselmann
	doc/design-2.1-lock-acquire.dot \
537 ca9ccea8 Michael Hanselmann
	doc/design-2.1-lock-release.dot
538 b8195800 Iustin Pop
539 d17e74b4 Iustin Pop
docpng = $(patsubst %.dot,%.png,$(docdot))
540 e8230860 Michael Hanselmann
541 7e1ccbe0 Michael Hanselmann
# Things to build but not to install (add it to EXTRA_DIST if it should be
542 7e1ccbe0 Michael Hanselmann
# distributed)
543 7e1ccbe0 Michael Hanselmann
noinst_DATA = \
544 7e1ccbe0 Michael Hanselmann
	devel/upload \
545 7e1ccbe0 Michael Hanselmann
	doc/html \
546 656a7fdf Iustin Pop
	$(BUILT_EXAMPLES) \
547 7e1ccbe0 Michael Hanselmann
	doc/examples/bash_completion \
548 e80aeb89 Michael Hanselmann
	doc/examples/bash_completion-debug \
549 7e1ccbe0 Michael Hanselmann
	$(manhtml)
550 f29266b4 Iustin Pop
551 4f3d5b76 Michael Hanselmann
gnt_scripts = \
552 e8230860 Michael Hanselmann
	scripts/gnt-backup \
553 e8230860 Michael Hanselmann
	scripts/gnt-cluster \
554 e8230860 Michael Hanselmann
	scripts/gnt-debug \
555 667dbd6b Adeodato Simo
	scripts/gnt-group \
556 e8230860 Michael Hanselmann
	scripts/gnt-instance \
557 e8230860 Michael Hanselmann
	scripts/gnt-job \
558 e8230860 Michael Hanselmann
	scripts/gnt-node \
559 e8230860 Michael Hanselmann
	scripts/gnt-os
560 e8230860 Michael Hanselmann
561 0d2bf835 René Nussbaumer
PYTHON_BOOTSTRAP_SBIN = \
562 29d91329 Michael Hanselmann
	daemons/ganeti-masterd \
563 5119f2ec Michael Hanselmann
	daemons/ganeti-noded \
564 d9c82a4e Michael Hanselmann
	daemons/ganeti-rapi \
565 dad26941 Iustin Pop
	daemons/ganeti-watcher \
566 656a7fdf Iustin Pop
	$(gnt_scripts)
567 2d48a3a2 Michael Hanselmann
568 0d2bf835 René Nussbaumer
PYTHON_BOOTSTRAP = \
569 0d2bf835 René Nussbaumer
	$(PYTHON_BOOTSTRAP_SBIN) \
570 0d2bf835 René Nussbaumer
	tools/ensure-dirs
571 0d2bf835 René Nussbaumer
572 a8c68e44 Michael Hanselmann
qa_scripts = \
573 a0c3e726 Michael Hanselmann
	qa/__init__.py \
574 a8c68e44 Michael Hanselmann
	qa/ganeti-qa.py \
575 a8c68e44 Michael Hanselmann
	qa/qa_cluster.py \
576 a8c68e44 Michael Hanselmann
	qa/qa_config.py \
577 a8c68e44 Michael Hanselmann
	qa/qa_daemon.py \
578 a8c68e44 Michael Hanselmann
	qa/qa_env.py \
579 a8c68e44 Michael Hanselmann
	qa/qa_error.py \
580 21bf2e2e Andrea Spadaccini
	qa/qa_group.py \
581 a8c68e44 Michael Hanselmann
	qa/qa_instance.py \
582 09470dd8 Michael Hanselmann
	qa/qa_job.py \
583 a8c68e44 Michael Hanselmann
	qa/qa_node.py \
584 a8c68e44 Michael Hanselmann
	qa/qa_os.py \
585 a8c68e44 Michael Hanselmann
	qa/qa_rapi.py \
586 a8c68e44 Michael Hanselmann
	qa/qa_tags.py \
587 a8c68e44 Michael Hanselmann
	qa/qa_utils.py
588 a8c68e44 Michael Hanselmann
589 d6159933 Iustin Pop
bin_SCRIPTS =
590 d6159933 Iustin Pop
if WANT_HTOOLS
591 c3f67183 Iustin Pop
bin_SCRIPTS += $(filter-out htools/hail,$(HS_PROGS))
592 458a286a Iustin Pop
install-exec-hook:
593 458a286a Iustin Pop
	@mkdir_p@ $(DESTDIR)$(iallocatorsdir)
594 7fa52acd Iustin Pop
# FIXME: this is a hardcoded logic, instead of auto-resolving
595 7fa52acd Iustin Pop
	$(LN_S) -f ../../../bin/htools \
596 458a286a Iustin Pop
		   $(DESTDIR)$(iallocatorsdir)/hail
597 201b6c34 Iustin Pop
	for role in $(HS_BIN_ROLES); do \
598 7fa52acd Iustin Pop
		$(LN_S) -f htools \
599 201b6c34 Iustin Pop
			   $(DESTDIR)$(bindir)/$$role ; \
600 201b6c34 Iustin Pop
	done
601 d6159933 Iustin Pop
endif
602 d6159933 Iustin Pop
603 51309138 Iustin Pop
$(HS_ALL_PROGS): %: %.hs $(HS_LIBTEST_SRCS) $(HS_BUILT_SRCS) Makefile
604 16a6192d Iustin Pop
	@if [ -z "$(HTOOLS)" ]; then \
605 16a6192d Iustin Pop
	  echo "Error: htools compilation disabled at configure time" 1>&2 ;\
606 16a6192d Iustin Pop
	  exit 1; \
607 16a6192d Iustin Pop
	fi
608 f0f3a6df Iustin Pop
	@if [ "$(notdir $@)" = "test" ] && [ -z "$(GHC_PKG_QUICKCHECK)" ]; then \
609 fd0bc853 Iustin Pop
	  echo "Error: cannot run unittests without the QuickCheck library (see devnotes.rst)" 1>&2; \
610 fd0bc853 Iustin Pop
	  exit 1; \
611 49e11c49 Iustin Pop
	fi
612 f0f3a6df Iustin Pop
	@rm -f $(notdir $@).tix
613 f0f3a6df Iustin Pop
	$(GHC) --make \
614 ef958f2a Iustin Pop
	  $(HFLAGS) \
615 1adec4be Iustin Pop
	  $(HTOOLS_NOCURL) $(HTOOLS_PARALLEL3) \
616 f0f3a6df Iustin Pop
	  -osuf $(notdir $@).o -hisuf $(notdir $@).hi \
617 c7ec3025 Iustin Pop
	  $(HEXTRA) $(HEXTRA_INT) $@
618 70b6c284 Iustin Pop
	@touch "$@"
619 70b6c284 Iustin Pop
620 f0f3a6df Iustin Pop
# for the htest/test binary, we need to enable profiling/coverage
621 f0f3a6df Iustin Pop
htest/test: HEXTRA_INT=-fhpc -ihtest
622 b91e9518 Iustin Pop
623 896b2850 Iustin Pop
# we compile the hpc-htools binary with the program coverage
624 f0f3a6df Iustin Pop
htest/hpc-htools: HEXTRA_INT=-fhpc
625 25cdf177 Iustin Pop
626 04d15e63 Iustin Pop
# test dependency
627 f0f3a6df Iustin Pop
htest/offline-tests.sh: htest/hpc-htools
628 04d15e63 Iustin Pop
629 c7ec3025 Iustin Pop
# rules for building profiling-enabled versions of the haskell
630 c7ec3025 Iustin Pop
# programs: hs-prof does the full two-step build, whereas
631 c7ec3025 Iustin Pop
# hs-prof-quick does only the final rebuild (hs-prof must have been
632 c7ec3025 Iustin Pop
# run before)
633 c7ec3025 Iustin Pop
.PHONY: hs-prof hs-prof-quick
634 c7ec3025 Iustin Pop
hs-prof:
635 b0b8458a Iustin Pop
	$(MAKE) $(AM_MAKEFLAGS) clean
636 b0b8458a Iustin Pop
	$(MAKE) $(AM_MAKEFLAGS) $(HS_ALL_PROGS) HEXTRA="-osuf .o"
637 c7ec3025 Iustin Pop
	rm -f $(HS_ALL_PROGS)
638 b0b8458a Iustin Pop
	$(MAKE) $(AM_MAKEFLAGS) hs-prof-quick
639 c7ec3025 Iustin Pop
640 c7ec3025 Iustin Pop
hs-prof-quick:
641 b0b8458a Iustin Pop
	$(MAKE) $(AM_MAKEFLAGS) $(HS_ALL_PROGS) HEXTRA="-osuf .prof_o -prof -auto-all"
642 c7ec3025 Iustin Pop
643 da7e44ee Michael Hanselmann
dist_sbin_SCRIPTS = \
644 da7e44ee Michael Hanselmann
	tools/ganeti-listrunner
645 4f3d5b76 Michael Hanselmann
646 fc3fd894 Michael Hanselmann
nodist_sbin_SCRIPTS = \
647 0d2bf835 René Nussbaumer
	$(PYTHON_BOOTSTRAP_SBIN) \
648 46118ed2 Iustin Pop
	daemons/ganeti-cleaner
649 fc3fd894 Michael Hanselmann
650 04520998 Iustin Pop
if ENABLE_CONFD
651 b0dcdc10 Iustin Pop
htools/ganeti-confd: htools/hconfd
652 b0dcdc10 Iustin Pop
	cp -f $< $@
653 b0dcdc10 Iustin Pop
654 b0dcdc10 Iustin Pop
nodist_sbin_SCRIPTS += htools/ganeti-confd
655 73b0fa69 Iustin Pop
endif
656 73b0fa69 Iustin Pop
657 cc120286 Bernardo Dal Seno
python_scripts = \
658 e8230860 Michael Hanselmann
	tools/burnin \
659 e8230860 Michael Hanselmann
	tools/cfgshell \
660 e8230860 Michael Hanselmann
	tools/cfgupgrade \
661 b5672ea0 Iustin Pop
	tools/cfgupgrade12 \
662 1f7d3f7d René Nussbaumer
	tools/cluster-merge \
663 4ef0399b Iustin Pop
	tools/confd-client \
664 d62cbd3a Michael Hanselmann
	tools/fmtjson \
665 ea5fd476 Iustin Pop
	tools/lvmstrap \
666 6bf273d5 Michael Hanselmann
	tools/move-instance \
667 ced78a66 Agata Murawska
	tools/ovfconverter \
668 dad26941 Iustin Pop
	tools/sanitize-config \
669 dad26941 Iustin Pop
	tools/setup-ssh
670 e8230860 Michael Hanselmann
671 61631293 Stephen Shirley
dist_tools_SCRIPTS = \
672 cc120286 Bernardo Dal Seno
	$(python_scripts) \
673 2f4c951e Stephen Shirley
	tools/kvm-console-wrapper \
674 dad26941 Iustin Pop
	tools/master-ip-setup \
675 dad26941 Iustin Pop
	tools/xm-console-wrapper
676 61631293 Stephen Shirley
677 29386d3e Michael Hanselmann
nodist_tools_SCRIPTS = \
678 29386d3e Michael Hanselmann
	tools/vcluster-setup
679 29386d3e Michael Hanselmann
680 2d76b580 Michael Hanselmann
pkglib_python_scripts = \
681 c6ccba7e Michael Hanselmann
	daemons/import-export \
682 c6ccba7e Michael Hanselmann
	tools/check-cert-expired
683 2d76b580 Michael Hanselmann
684 0d2bf835 René Nussbaumer
nodist_pkglib_python_scripts = \
685 0d2bf835 René Nussbaumer
	tools/ensure-dirs
686 0d2bf835 René Nussbaumer
687 b8fe7ca6 Iustin Pop
myexeclib_SCRIPTS = \
688 2d76b580 Michael Hanselmann
	daemons/daemon-util \
689 26916aad Apollon Oikonomopoulos
	tools/kvm-ifup \
690 2d76b580 Michael Hanselmann
	$(pkglib_python_scripts)
691 f154a7a3 Michael Hanselmann
692 b8fe7ca6 Iustin Pop
nodist_myexeclib_SCRIPTS = \
693 0d2bf835 René Nussbaumer
	$(nodist_pkglib_python_scripts)
694 0d2bf835 René Nussbaumer
695 e8230860 Michael Hanselmann
EXTRA_DIST = \
696 e8230860 Michael Hanselmann
	NEWS \
697 7a03d293 Michael Hanselmann
	UPGRADE \
698 f774bd03 Michael Hanselmann
	epydoc.conf.in \
699 70c771f6 Michael Hanselmann
	pylintrc \
700 bb46a96c Michael Hanselmann
	autotools/build-bash-completion \
701 d5a2a550 Michael Hanselmann
	autotools/build-rpc \
702 5d3c30df Michael Hanselmann
	autotools/check-header \
703 f6cbcc06 Michael Hanselmann
	autotools/check-imports \
704 c55cc346 Iustin Pop
	autotools/check-man-dashes \
705 73d0e218 Iustin Pop
	autotools/check-man-warnings \
706 c81ed2b2 Michael Hanselmann
	autotools/check-news \
707 dad26941 Iustin Pop
	autotools/check-python-code \
708 e627fe09 Michael Hanselmann
	autotools/check-tar \
709 96602be4 Michael Hanselmann
	autotools/check-version \
710 d99d1e36 Iustin Pop
	autotools/convert-constants \
711 95eb4188 Michael Hanselmann
	autotools/docpp \
712 27e336af Michael Hanselmann
	autotools/gen-coverage \
713 df69e0a0 Bernardo Dal Seno
	autotools/testrunner \
714 387863a5 Iustin Pop
	autotools/wrong-hardcoded-paths \
715 f3313af5 Guido Trotter
	$(RUN_IN_TEMPDIR) \
716 f154a7a3 Michael Hanselmann
	daemons/daemon-util.in \
717 fc3fd894 Michael Hanselmann
	daemons/ganeti-cleaner.in \
718 2d76b580 Michael Hanselmann
	$(pkglib_python_scripts) \
719 e8230860 Michael Hanselmann
	devel/upload.in \
720 26916aad Apollon Oikonomopoulos
	tools/kvm-ifup.in \
721 29386d3e Michael Hanselmann
	tools/vcluster-setup.in \
722 b8195800 Iustin Pop
	$(docdot) \
723 f727d134 Michael Hanselmann
	$(docpng) \
724 d17e74b4 Iustin Pop
	$(docrst) \
725 d17e74b4 Iustin Pop
	doc/conf.py \
726 d17e74b4 Iustin Pop
	doc/html \
727 656a7fdf Iustin Pop
	$(BUILT_EXAMPLES:%=%.in) \
728 752a8ca8 Michael Hanselmann
	doc/examples/ganeti.default \
729 752a8ca8 Michael Hanselmann
	doc/examples/ganeti.default-debug \
730 d6d9ce45 Guido Trotter
	doc/examples/hooks/ethers \
731 89c04c2d Guido Trotter
	doc/examples/gnt-debug/README \
732 89c04c2d Guido Trotter
	doc/examples/gnt-debug/delay0.json \
733 89c04c2d Guido Trotter
	doc/examples/gnt-debug/delay50.json \
734 e4d452b4 Michael Hanselmann
	test/lockperf.py \
735 e8230860 Michael Hanselmann
	test/testutils.py \
736 e8230860 Michael Hanselmann
	test/mocks.py \
737 e8230860 Michael Hanselmann
	$(dist_TESTS) \
738 e8230860 Michael Hanselmann
	$(TEST_FILES) \
739 6be8e2bf Iustin Pop
	man/footer.rst \
740 6be8e2bf Iustin Pop
	$(manrst) \
741 f727d134 Michael Hanselmann
	$(maninput) \
742 39e0d19e Michael Hanselmann
	qa/qa-sample.json \
743 d6159933 Iustin Pop
	$(qa_scripts) \
744 51309138 Iustin Pop
	$(HS_LIBTEST_SRCS) $(HS_BUILT_SRCS_IN) \
745 5a1e31b4 Iustin Pop
	$(HS_PROG_SRCS) \
746 04d15e63 Iustin Pop
	htools/lint-hints.hs \
747 f0f3a6df Iustin Pop
	htest/cli-tests-defs.sh \
748 f0f3a6df Iustin Pop
	htest/offline-test.sh
749 e8230860 Michael Hanselmann
750 e8230860 Michael Hanselmann
man_MANS = \
751 bae7e531 Michael Hanselmann
	man/ganeti-cleaner.8 \
752 b7b7cda6 Guido Trotter
	man/ganeti-confd.8 \
753 da7e44ee Michael Hanselmann
	man/ganeti-listrunner.8 \
754 320d986d Iustin Pop
	man/ganeti-masterd.8 \
755 e8230860 Michael Hanselmann
	man/ganeti-noded.8 \
756 e8230860 Michael Hanselmann
	man/ganeti-os-interface.7 \
757 320d986d Iustin Pop
	man/ganeti-rapi.8 \
758 e8230860 Michael Hanselmann
	man/ganeti-watcher.8 \
759 dad26941 Iustin Pop
	man/ganeti.7 \
760 e8230860 Michael Hanselmann
	man/gnt-backup.8 \
761 e8230860 Michael Hanselmann
	man/gnt-cluster.8 \
762 d3b4cf9f Iustin Pop
	man/gnt-debug.8 \
763 667dbd6b Adeodato Simo
	man/gnt-group.8 \
764 e8230860 Michael Hanselmann
	man/gnt-instance.8 \
765 d3b4cf9f Iustin Pop
	man/gnt-job.8 \
766 e8230860 Michael Hanselmann
	man/gnt-node.8 \
767 5a19bd35 Iustin Pop
	man/gnt-os.8 \
768 5a19bd35 Iustin Pop
	man/hail.1 \
769 5a19bd35 Iustin Pop
	man/hbal.1 \
770 f18e4168 Iustin Pop
	man/hcheck.1 \
771 e2bdaf25 René Nussbaumer
	man/hinfo.1 \
772 5a19bd35 Iustin Pop
	man/hscan.1 \
773 d26d808a Iustin Pop
	man/hspace.1 \
774 d26d808a Iustin Pop
	man/htools.1
775 e8230860 Michael Hanselmann
776 5a19bd35 Iustin Pop
manrst = $(patsubst %.1,%.rst,$(patsubst %.7,%.rst,$(patsubst %.8,%.rst,$(man_MANS))))
777 6be8e2bf Iustin Pop
manhtml = $(patsubst %.rst,%.html,$(manrst))
778 fcdb582d Michael Hanselmann
mangen = $(patsubst %.rst,%.gen,$(manrst))
779 25c92bc5 Michael Hanselmann
maninput = \
780 5a19bd35 Iustin Pop
	$(patsubst %.1,%.1.in,$(patsubst %.7,%.7.in,$(patsubst %.8,%.8.in,$(man_MANS)))) \
781 de8eea3e Iustin Pop
	$(patsubst %.html,%.html.in,$(manhtml)) \
782 fcdb582d Michael Hanselmann
	man/footer.man man/footer.html $(mangen)
783 e8230860 Michael Hanselmann
784 e8230860 Michael Hanselmann
TEST_FILES = \
785 dad26941 Iustin Pop
	htest/data/common-suffix.data \
786 dad26941 Iustin Pop
	htest/data/hail-alloc-drbd.json \
787 dad26941 Iustin Pop
	htest/data/hail-change-group.json \
788 dad26941 Iustin Pop
	htest/data/hail-invalid-reloc.json \
789 dad26941 Iustin Pop
	htest/data/hail-node-evac.json \
790 dad26941 Iustin Pop
	htest/data/hail-reloc-drbd.json \
791 dad26941 Iustin Pop
	htest/data/hbal-split-insts.data \
792 dad26941 Iustin Pop
	htest/data/invalid-node.data \
793 dad26941 Iustin Pop
	htest/data/missing-resources.data \
794 dad26941 Iustin Pop
	htest/data/rapi/groups.json \
795 dad26941 Iustin Pop
	htest/data/rapi/info.json \
796 dad26941 Iustin Pop
	htest/data/rapi/instances.json \
797 dad26941 Iustin Pop
	htest/data/rapi/nodes.json \
798 dad26941 Iustin Pop
	htest/shelltests/htools-balancing.test \
799 dad26941 Iustin Pop
	htest/shelltests/htools-basic.test \
800 dad26941 Iustin Pop
	htest/shelltests/htools-dynutil.test \
801 dad26941 Iustin Pop
	htest/shelltests/htools-excl.test \
802 dad26941 Iustin Pop
	htest/shelltests/htools-hail.test \
803 dad26941 Iustin Pop
	htest/shelltests/htools-hspace.test \
804 dad26941 Iustin Pop
	htest/shelltests/htools-invalid.test \
805 dad26941 Iustin Pop
	htest/shelltests/htools-multi-group.test \
806 dad26941 Iustin Pop
	htest/shelltests/htools-no-backend.test \
807 dad26941 Iustin Pop
	htest/shelltests/htools-rapi.test \
808 dad26941 Iustin Pop
	htest/shelltests/htools-single-group.test \
809 dad26941 Iustin Pop
	htest/shelltests/htools-text-backend.test \
810 5a672c30 Manuel Franceschini
	test/data/bdev-drbd-8.0.txt \
811 5a672c30 Manuel Franceschini
	test/data/bdev-drbd-8.3.txt \
812 5a672c30 Manuel Franceschini
	test/data/bdev-drbd-disk.txt \
813 5a672c30 Manuel Franceschini
	test/data/bdev-drbd-net-ip4.txt \
814 5a672c30 Manuel Franceschini
	test/data/bdev-drbd-net-ip6.txt \
815 27e46076 Michael Hanselmann
	test/data/cert1.pem \
816 e5d1d1b5 Andrea Spadaccini
	test/data/ip-addr-show-dummy0.txt \
817 e5d1d1b5 Andrea Spadaccini
	test/data/ip-addr-show-lo-ipv4.txt \
818 e5d1d1b5 Andrea Spadaccini
	test/data/ip-addr-show-lo-ipv6.txt \
819 e5d1d1b5 Andrea Spadaccini
	test/data/ip-addr-show-lo-oneline-ipv4.txt \
820 e5d1d1b5 Andrea Spadaccini
	test/data/ip-addr-show-lo-oneline-ipv6.txt \
821 e5d1d1b5 Andrea Spadaccini
	test/data/ip-addr-show-lo-oneline.txt \
822 e5d1d1b5 Andrea Spadaccini
	test/data/ip-addr-show-lo.txt \
823 585c8187 Guido Trotter
	test/data/kvm_0.12.5_help.txt \
824 dad26941 Iustin Pop
	test/data/kvm_0.15.90_help.txt \
825 585c8187 Guido Trotter
	test/data/kvm_0.9.1_help.txt \
826 dad26941 Iustin Pop
	test/data/kvm_1.0_help.txt \
827 1e6fab60 Agata Murawska
	test/data/ovfdata/compr_disk.vmdk.gz \
828 d92518d3 Agata Murawska
	test/data/ovfdata/config.ini \
829 1e6fab60 Agata Murawska
	test/data/ovfdata/corrupted_resources.ovf \
830 d92518d3 Agata Murawska
	test/data/ovfdata/empty.ini \
831 1e6fab60 Agata Murawska
	test/data/ovfdata/empty.ovf \
832 1e6fab60 Agata Murawska
	test/data/ovfdata/ganeti.mf \
833 1e6fab60 Agata Murawska
	test/data/ovfdata/ganeti.ovf \
834 1e6fab60 Agata Murawska
	test/data/ovfdata/gzip_disk.ovf \
835 1e6fab60 Agata Murawska
	test/data/ovfdata/new_disk.vmdk \
836 d92518d3 Agata Murawska
	test/data/ovfdata/no_disk.ini \
837 1e6fab60 Agata Murawska
	test/data/ovfdata/no_disk_in_ref.ovf \
838 d92518d3 Agata Murawska
	test/data/ovfdata/no_os.ini \
839 1e6fab60 Agata Murawska
	test/data/ovfdata/no_ovf.ova \
840 dad26941 Iustin Pop
	test/data/ovfdata/other/rawdisk.raw \
841 1e6fab60 Agata Murawska
	test/data/ovfdata/ova.ova \
842 d92518d3 Agata Murawska
	test/data/ovfdata/rawdisk.raw \
843 dad26941 Iustin Pop
	test/data/ovfdata/second_disk.vmdk \
844 d92518d3 Agata Murawska
	test/data/ovfdata/unsafe_path.ini \
845 1e6fab60 Agata Murawska
	test/data/ovfdata/virtualbox.ovf \
846 d92518d3 Agata Murawska
	test/data/ovfdata/wrong_config.ini \
847 dad26941 Iustin Pop
	test/data/ovfdata/wrong_extension.ovd \
848 1e6fab60 Agata Murawska
	test/data/ovfdata/wrong_manifest.mf \
849 1e6fab60 Agata Murawska
	test/data/ovfdata/wrong_manifest.ovf \
850 1e6fab60 Agata Murawska
	test/data/ovfdata/wrong_ova.ova \
851 1e6fab60 Agata Murawska
	test/data/ovfdata/wrong_xml.ovf \
852 dad26941 Iustin Pop
	test/data/proc_drbd8.txt \
853 dad26941 Iustin Pop
	test/data/proc_drbd80-emptyline.txt \
854 dad26941 Iustin Pop
	test/data/proc_drbd83.txt \
855 dad26941 Iustin Pop
	test/data/proc_drbd83_sync.txt \
856 dad26941 Iustin Pop
	test/data/proc_drbd83_sync_krnl2.6.39.txt \
857 dad26941 Iustin Pop
	test/data/sys_drbd_usermode_helper.txt \
858 1a1e7ab3 Iustin Pop
	test/data/vgreduce-removemissing-2.02.02.txt \
859 1a1e7ab3 Iustin Pop
	test/data/vgreduce-removemissing-2.02.66-fail.txt \
860 1a1e7ab3 Iustin Pop
	test/data/vgreduce-removemissing-2.02.66-ok.txt \
861 1a1e7ab3 Iustin Pop
	test/data/vgs-missing-pvs-2.02.02.txt \
862 1a1e7ab3 Iustin Pop
	test/data/vgs-missing-pvs-2.02.66.txt \
863 30f2802f Iustin Pop
	test/ganeti-cli.test \
864 dad26941 Iustin Pop
	test/gnt-cli.test \
865 dad26941 Iustin Pop
	test/import-export_unittest-helper
866 e8230860 Michael Hanselmann
867 e8c8cf1a Michael Hanselmann
python_tests = \
868 3ade0e0e Michael Hanselmann
	doc/examples/rapi_testutils.py \
869 dad26941 Iustin Pop
	test/cfgupgrade_unittest.py \
870 dad26941 Iustin Pop
	test/docs_unittest.py \
871 17496050 Guido Trotter
	test/ganeti.asyncnotifier_unittest.py \
872 f942a838 Michael Hanselmann
	test/ganeti.backend_unittest.py \
873 6de7c41d Iustin Pop
	test/ganeti.bdev_unittest.py \
874 6de7c41d Iustin Pop
	test/ganeti.cli_unittest.py \
875 66d1f035 René Nussbaumer
	test/ganeti.client.gnt_cluster_unittest.py \
876 25ce3ec4 Michael Hanselmann
	test/ganeti.client.gnt_instance_unittest.py \
877 6de7c41d Iustin Pop
	test/ganeti.cmdlib_unittest.py \
878 cea881e5 Michael Hanselmann
	test/ganeti.compat_unittest.py \
879 edf7d66e Iustin Pop
	test/ganeti.confd.client_unittest.py \
880 e8230860 Michael Hanselmann
	test/ganeti.config_unittest.py \
881 6de7c41d Iustin Pop
	test/ganeti.constants_unittest.py \
882 dad26941 Iustin Pop
	test/ganeti.daemon_unittest.py \
883 3bd19c66 Michael Hanselmann
	test/ganeti.errors_unittest.py \
884 e8230860 Michael Hanselmann
	test/ganeti.hooks_unittest.py \
885 ecdf0398 Michael Hanselmann
	test/ganeti.ht_unittest.py \
886 6de7c41d Iustin Pop
	test/ganeti.http_unittest.py \
887 55cc0a44 Michael Hanselmann
	test/ganeti.hypervisor.hv_chroot_unittest.py \
888 55cc0a44 Michael Hanselmann
	test/ganeti.hypervisor.hv_fake_unittest.py \
889 748e4b5a Michael Hanselmann
	test/ganeti.hypervisor.hv_kvm_unittest.py \
890 55cc0a44 Michael Hanselmann
	test/ganeti.hypervisor.hv_lxc_unittest.py \
891 55cc0a44 Michael Hanselmann
	test/ganeti.hypervisor.hv_xen_unittest.py \
892 dad26941 Iustin Pop
	test/ganeti.hypervisor_unittest.py \
893 bb44b1ae Michael Hanselmann
	test/ganeti.impexpd_unittest.py \
894 989a8bee Michael Hanselmann
	test/ganeti.jqueue_unittest.py \
895 6f1aa78d Michael Hanselmann
	test/ganeti.jstore_unittest.py \
896 e8230860 Michael Hanselmann
	test/ganeti.locking_unittest.py \
897 231db3a5 Michael Hanselmann
	test/ganeti.luxi_unittest.py \
898 33b4fa9f René Nussbaumer
	test/ganeti.masterd.iallocator_unittest.py \
899 033a1d00 Michael Hanselmann
	test/ganeti.masterd.instance_unittest.py \
900 407339d0 Michael Hanselmann
	test/ganeti.mcpu_unittest.py \
901 a744b676 Manuel Franceschini
	test/ganeti.netutils_unittest.py \
902 4c14965f Guido Trotter
	test/ganeti.objects_unittest.py \
903 32683096 René Nussbaumer
	test/ganeti.objectutils_unittest.py \
904 c32b908e Michael Hanselmann
	test/ganeti.opcodes_unittest.py \
905 1e6fab60 Agata Murawska
	test/ganeti.ovf_unittest.py \
906 a123dc19 Michael Hanselmann
	test/ganeti.qlang_unittest.py \
907 4ca96421 Michael Hanselmann
	test/ganeti.query_unittest.py \
908 cfaeaaf7 Michael Hanselmann
	test/ganeti.rapi.baserlib_unittest.py \
909 95ab4de9 David Knowles
	test/ganeti.rapi.client_unittest.py \
910 4cbd4462 Oleksiy Mishchenko
	test/ganeti.rapi.resources_unittest.py \
911 6395cebb Michael Hanselmann
	test/ganeti.rapi.rlib2_unittest.py \
912 a85f23fa Michael Hanselmann
	test/ganeti.rapi.testutils_unittest.py \
913 33231500 Michael Hanselmann
	test/ganeti.rpc_unittest.py \
914 f12e1736 René Nussbaumer
	test/ganeti.runtime_unittest.py \
915 6de7c41d Iustin Pop
	test/ganeti.serializer_unittest.py \
916 6de7c41d Iustin Pop
	test/ganeti.ssh_unittest.py \
917 048eeb2b Iustin Pop
	test/ganeti.storage_unittest.py \
918 0d2bf835 René Nussbaumer
	test/ganeti.tools.ensure_dirs_unittest.py \
919 93be53da Balazs Lecz
	test/ganeti.uidpool_unittest.py \
920 4fd029cf Michael Hanselmann
	test/ganeti.utils.algo_unittest.py \
921 9d1b963f Michael Hanselmann
	test/ganeti.utils.filelock_unittest.py \
922 f21bb4b7 Michael Hanselmann
	test/ganeti.utils.hash_unittest.py \
923 7ebadeb3 Bernardo Dal Seno
	test/ganeti.utils.io_unittest-runasroot.py \
924 dad26941 Iustin Pop
	test/ganeti.utils.io_unittest.py \
925 b6fa9a44 Michael Hanselmann
	test/ganeti.utils.log_unittest.py \
926 8dc76d54 Guido Trotter
	test/ganeti.utils.mlock_unittest.py \
927 17b97ab3 Michael Hanselmann
	test/ganeti.utils.nodesetup_unittest.py \
928 a4ccecf6 Michael Hanselmann
	test/ganeti.utils.process_unittest.py \
929 79d22269 Michael Hanselmann
	test/ganeti.utils.retry_unittest.py \
930 7fcffe27 Michael Hanselmann
	test/ganeti.utils.text_unittest.py \
931 7831fc5f Michael Hanselmann
	test/ganeti.utils.wrapper_unittest.py \
932 c50645c0 Michael Hanselmann
	test/ganeti.utils.x509_unittest.py \
933 4fd029cf Michael Hanselmann
	test/ganeti.utils_unittest.py \
934 05e733b4 Michael Hanselmann
	test/ganeti.vcluster_unittest.py \
935 3f991867 Michael Hanselmann
	test/ganeti.workerpool_unittest.py \
936 4fd2660d Michael Hanselmann
	test/pycurl_reset_unittest.py \
937 dad26941 Iustin Pop
	test/qa.qa_config_unittest.py \
938 055f822b Michael Hanselmann
	test/tempfile_fork_unittest.py
939 e8230860 Michael Hanselmann
940 f0f3a6df Iustin Pop
haskell_tests = htest/test
941 b91e9518 Iustin Pop
942 e8c8cf1a Michael Hanselmann
dist_TESTS = \
943 7172f605 Michael Hanselmann
	test/check-cert-expired_unittest.bash \
944 571b34f8 Michael Hanselmann
	test/daemon-util_unittest.bash \
945 7172f605 Michael Hanselmann
	test/ganeti-cleaner_unittest.bash \
946 2d76b580 Michael Hanselmann
	test/import-export_unittest.bash \
947 30f2802f Iustin Pop
	test/cli-test.bash \
948 92886204 Michael Hanselmann
	test/bash_completion.bash \
949 e8c8cf1a Michael Hanselmann
	$(python_tests)
950 e8c8cf1a Michael Hanselmann
951 e8230860 Michael Hanselmann
nodist_TESTS =
952 d3cd5a3f Iustin Pop
check_SCRIPTS =
953 d3cd5a3f Iustin Pop
954 e5f6768c Iustin Pop
if WANT_HTOOLSTESTS
955 b91e9518 Iustin Pop
nodist_TESTS += $(haskell_tests)
956 f0f3a6df Iustin Pop
dist_TESTS += htest/offline-test.sh
957 f0f3a6df Iustin Pop
check_SCRIPTS += htest/hpc-htools $(HS_BUILT_TEST_HELPERS)
958 b91e9518 Iustin Pop
endif
959 e8230860 Michael Hanselmann
960 e8230860 Michael Hanselmann
TESTS = $(dist_TESTS) $(nodist_TESTS)
961 e8230860 Michael Hanselmann
962 27e336af Michael Hanselmann
# Environment for all tests
963 27e336af Michael Hanselmann
PLAIN_TESTS_ENVIRONMENT = \
964 30f2802f Iustin Pop
	PYTHONPATH=. \
965 30f2802f Iustin Pop
	TOP_SRCDIR=$(abs_top_srcdir) TOP_BUILDDIR=$(abs_top_builddir) \
966 30f2802f Iustin Pop
	PYTHON=$(PYTHON) FAKEROOT=$(FAKEROOT_PATH) \
967 30f2802f Iustin Pop
	$(RUN_IN_TEMPDIR)
968 27e336af Michael Hanselmann
969 27e336af Michael Hanselmann
# Environment for tests run by automake
970 f848ac00 Michael Hanselmann
TESTS_ENVIRONMENT = \
971 e8c8cf1a Michael Hanselmann
	$(PLAIN_TESTS_ENVIRONMENT) $(abs_top_srcdir)/autotools/testrunner
972 6e06b36c Iustin Pop
973 eed5c5df Michael Hanselmann
all_python_code = \
974 01a3a718 Michael Hanselmann
	$(dist_sbin_SCRIPTS) \
975 cc120286 Bernardo Dal Seno
	$(python_scripts) \
976 2d76b580 Michael Hanselmann
	$(pkglib_python_scripts) \
977 0d2bf835 René Nussbaumer
	$(nodist_pkglib_python_scripts) \
978 e8c8cf1a Michael Hanselmann
	$(python_tests) \
979 01a3a718 Michael Hanselmann
	$(pkgpython_PYTHON) \
980 2d48a3a2 Michael Hanselmann
	$(client_PYTHON) \
981 01a3a718 Michael Hanselmann
	$(hypervisor_PYTHON) \
982 01a3a718 Michael Hanselmann
	$(rapi_PYTHON) \
983 899c4d2c Michael Hanselmann
	$(server_PYTHON) \
984 0d2bf835 René Nussbaumer
	$(pytools_PYTHON) \
985 01a3a718 Michael Hanselmann
	$(http_PYTHON) \
986 01a3a718 Michael Hanselmann
	$(confd_PYTHON) \
987 dc101ecc Michael Hanselmann
	$(masterd_PYTHON) \
988 bb44b1ae Michael Hanselmann
	$(impexpd_PYTHON) \
989 c047a981 Michael Hanselmann
	$(utils_PYTHON) \
990 9f4bb951 Michael Hanselmann
	$(watcher_PYTHON) \
991 a8c68e44 Michael Hanselmann
	$(noinst_PYTHON) \
992 a8c68e44 Michael Hanselmann
	$(qa_scripts)
993 01a3a718 Michael Hanselmann
994 eed5c5df Michael Hanselmann
srclink_files = \
995 6be8e2bf Iustin Pop
	man/footer.rst \
996 7172f605 Michael Hanselmann
	test/check-cert-expired_unittest.bash \
997 571b34f8 Michael Hanselmann
	test/daemon-util_unittest.bash \
998 7172f605 Michael Hanselmann
	test/ganeti-cleaner_unittest.bash \
999 2d76b580 Michael Hanselmann
	test/import-export_unittest.bash \
1000 30f2802f Iustin Pop
	test/cli-test.bash \
1001 92886204 Michael Hanselmann
	test/bash_completion.bash \
1002 f0f3a6df Iustin Pop
	htest/offline-test.sh \
1003 f0f3a6df Iustin Pop
	htest/cli-tests-defs.sh \
1004 d6159933 Iustin Pop
	$(all_python_code) \
1005 51309138 Iustin Pop
	$(HS_LIBTEST_SRCS) $(HS_PROG_SRCS)
1006 eed5c5df Michael Hanselmann
1007 eed5c5df Michael Hanselmann
check_python_code = \
1008 e4e7c7df Michael Hanselmann
	$(BUILD_BASH_COMPLETION) \
1009 f6cbcc06 Michael Hanselmann
	$(CHECK_IMPORTS) \
1010 5d3c30df Michael Hanselmann
	$(CHECK_HEADER) \
1011 95eb4188 Michael Hanselmann
	$(DOCPP) \
1012 eed5c5df Michael Hanselmann
	$(all_python_code)
1013 eed5c5df Michael Hanselmann
1014 e4e7c7df Michael Hanselmann
lint_python_code = \
1015 f60d352e Michael Hanselmann
	ganeti \
1016 f1763373 Iustin Pop
	ganeti/http/server.py \
1017 f60d352e Michael Hanselmann
	$(dist_sbin_SCRIPTS) \
1018 cc120286 Bernardo Dal Seno
	$(python_scripts) \
1019 2d76b580 Michael Hanselmann
	$(pkglib_python_scripts) \
1020 2cc8bdd0 Michael Hanselmann
	$(BUILD_BASH_COMPLETION) \
1021 f6cbcc06 Michael Hanselmann
	$(CHECK_IMPORTS) \
1022 5d3c30df Michael Hanselmann
	$(CHECK_HEADER) \
1023 95eb4188 Michael Hanselmann
	$(DOCPP) \
1024 2cc8bdd0 Michael Hanselmann
	$(PYTHON_BOOTSTRAP)
1025 eed5c5df Michael Hanselmann
1026 f6cbcc06 Michael Hanselmann
standalone_python_modules = \
1027 f6cbcc06 Michael Hanselmann
	lib/rapi/client.py \
1028 f6cbcc06 Michael Hanselmann
	tools/ganeti-listrunner
1029 f6cbcc06 Michael Hanselmann
1030 21bf2e2e Andrea Spadaccini
pep8_python_code = \
1031 21bf2e2e Andrea Spadaccini
	ganeti \
1032 21bf2e2e Andrea Spadaccini
	ganeti/http/server.py \
1033 21bf2e2e Andrea Spadaccini
	$(dist_sbin_SCRIPTS) \
1034 cc120286 Bernardo Dal Seno
	$(python_scripts) \
1035 21bf2e2e Andrea Spadaccini
	$(pkglib_python_scripts) \
1036 21bf2e2e Andrea Spadaccini
	$(BUILD_BASH_COMPLETION) \
1037 5d3c30df Michael Hanselmann
	$(CHECK_HEADER) \
1038 21bf2e2e Andrea Spadaccini
	$(DOCPP) \
1039 21bf2e2e Andrea Spadaccini
	$(PYTHON_BOOTSTRAP) \
1040 21bf2e2e Andrea Spadaccini
	qa
1041 21bf2e2e Andrea Spadaccini
1042 571b34f8 Michael Hanselmann
test/daemon-util_unittest.bash: daemons/daemon-util
1043 571b34f8 Michael Hanselmann
1044 46118ed2 Iustin Pop
test/ganeti-cleaner_unittest.bash: daemons/ganeti-cleaner
1045 7172f605 Michael Hanselmann
1046 92886204 Michael Hanselmann
test/bash_completion.bash: doc/examples/bash_completion-debug
1047 92886204 Michael Hanselmann
1048 26916aad Apollon Oikonomopoulos
tools/kvm-ifup: tools/kvm-ifup.in $(REPLACE_VARS_SED)
1049 26916aad Apollon Oikonomopoulos
	sed -f $(REPLACE_VARS_SED) < $< > $@
1050 26916aad Apollon Oikonomopoulos
	chmod +x $@
1051 26916aad Apollon Oikonomopoulos
1052 dbefcc7e Michael Hanselmann
devel/upload: devel/upload.in $(REPLACE_VARS_SED)
1053 e8230860 Michael Hanselmann
	sed -f $(REPLACE_VARS_SED) < $< > $@
1054 e8230860 Michael Hanselmann
	chmod u+x $@
1055 e8230860 Michael Hanselmann
1056 29386d3e Michael Hanselmann
tools/vcluster-setup: tools/vcluster-setup.in $(REPLACE_VARS_SED)
1057 29386d3e Michael Hanselmann
	sed -f $(REPLACE_VARS_SED) < $< > $@
1058 29386d3e Michael Hanselmann
	chmod +x $@
1059 29386d3e Michael Hanselmann
1060 490bec02 Iustin Pop
daemons/%:: daemons/%.in $(REPLACE_VARS_SED)
1061 e8230860 Michael Hanselmann
	sed -f $(REPLACE_VARS_SED) < $< > $@
1062 5c566e17 Michael Hanselmann
	chmod +x $@
1063 e8230860 Michael Hanselmann
1064 490bec02 Iustin Pop
doc/examples/%:: doc/examples/%.in $(REPLACE_VARS_SED)
1065 e8230860 Michael Hanselmann
	sed -f $(REPLACE_VARS_SED) < $< > $@
1066 e8230860 Michael Hanselmann
1067 e80aeb89 Michael Hanselmann
doc/examples/bash_completion: BC_ARGS = --compact
1068 e80aeb89 Michael Hanselmann
doc/examples/bash_completion-debug: BC_ARGS =
1069 e80aeb89 Michael Hanselmann
1070 e80aeb89 Michael Hanselmann
doc/examples/bash_completion doc/examples/bash_completion-debug: \
1071 e80aeb89 Michael Hanselmann
	$(BUILD_BASH_COMPLETION) $(RUN_IN_TEMPDIR) \
1072 4c3d5fb6 Iustin Pop
	lib/cli.py $(gnt_scripts) $(client_PYTHON) tools/burnin \
1073 46118ed2 Iustin Pop
	daemons/ganeti-cleaner \
1074 ada0e680 Iustin Pop
	$(GENERATED_FILES) $(HTOOLS_GENERATED_FILES)
1075 e80aeb89 Michael Hanselmann
	PYTHONPATH=. $(RUN_IN_TEMPDIR) \
1076 e80aeb89 Michael Hanselmann
	  $(CURDIR)/$(BUILD_BASH_COMPLETION) $(BC_ARGS) > $@
1077 4f3d5b76 Michael Hanselmann
1078 f86e82ef Iustin Pop
doc/%.png: doc/%.dot
1079 2ab2b9f5 Iustin Pop
	@test -n "$(DOT)" || { echo 'dot' not found during configure; exit 1; }
1080 f86e82ef Iustin Pop
	$(DOT) -Tpng -o $@ $<
1081 f86e82ef Iustin Pop
1082 de8eea3e Iustin Pop
man/footer.man: man/footer.rst
1083 de8eea3e Iustin Pop
	@test -n "$(PANDOC)" || \
1084 de8eea3e Iustin Pop
	  { echo 'pandoc' not found during configure; exit 1; }
1085 de8eea3e Iustin Pop
	$(PANDOC) -f rst -t man -o $@ $<
1086 de8eea3e Iustin Pop
1087 6be8e2bf Iustin Pop
man/footer.html: man/footer.rst
1088 6be8e2bf Iustin Pop
	@test -n "$(PANDOC)" || \
1089 6be8e2bf Iustin Pop
	  { echo 'pandoc' not found during configure; exit 1; }
1090 6be8e2bf Iustin Pop
	$(PANDOC) -f rst -t html -o $@ $<
1091 6be8e2bf Iustin Pop
1092 7142485a Iustin Pop
man/%.gen: man/%.rst lib/query.py lib/build/sphinx_ext.py \
1093 d7772efa Iustin Pop
	lib/build/shell_example_lexer.py \
1094 a13d6911 Iustin Pop
	| $(RUN_IN_TEMPDIR) $(BUILT_PYTHON_SOURCES)
1095 387863a5 Iustin Pop
	@echo "Checking $< for hardcoded paths..."
1096 387863a5 Iustin Pop
	@if grep -nEf autotools/wrong-hardcoded-paths $<; then \
1097 387863a5 Iustin Pop
	  echo "Man page $< has harcoded paths (see above)!" 1>&2 ; \
1098 387863a5 Iustin Pop
	  exit 1; \
1099 387863a5 Iustin Pop
	fi
1100 a13d6911 Iustin Pop
	set -e ; \
1101 a13d6911 Iustin Pop
	trap 'echo auto-removing $@; rm $@' EXIT; \
1102 a13d6911 Iustin Pop
	PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(DOCPP) < $< > $@ ;\
1103 a13d6911 Iustin Pop
	trap - EXIT
1104 fcdb582d Michael Hanselmann
1105 5a19bd35 Iustin Pop
man/%.7.in man/%.8.in man/%.1.in: man/%.gen man/footer.man
1106 6be8e2bf Iustin Pop
	@test -n "$(PANDOC)" || \
1107 6be8e2bf Iustin Pop
	  { echo 'pandoc' not found during configure; exit 1; }
1108 a01dd3c6 Iustin Pop
	set -o pipefail ; \
1109 9c45babb Iustin Pop
	trap 'echo auto-removing $@; rm $@' EXIT; \
1110 6be8e2bf Iustin Pop
	$(PANDOC) -s -f rst -t man -A man/footer.man $< | \
1111 9c45babb Iustin Pop
	  sed -e 's/\\@/@/g' > $@; \
1112 73d0e218 Iustin Pop
	if test -n "$(MAN_HAS_WARNINGS)"; then $(CHECK_MAN_WARNINGS) $@; fi; \
1113 c55cc346 Iustin Pop
	$(CHECK_MAN_DASHES) $@; \
1114 9c45babb Iustin Pop
	trap - EXIT
1115 9c45babb Iustin Pop
1116 2ab2b9f5 Iustin Pop
1117 fcdb582d Michael Hanselmann
man/%.html.in: man/%.gen man/footer.html
1118 6be8e2bf Iustin Pop
	@test -n "$(PANDOC)" || \
1119 6be8e2bf Iustin Pop
	  { echo 'pandoc' not found during configure; exit 1; }
1120 a01dd3c6 Iustin Pop
	set -o pipefail ; \
1121 6be8e2bf Iustin Pop
	$(PANDOC) -s -f rst -t html -A man/footer.html $< | \
1122 6be8e2bf Iustin Pop
	  sed -e 's/\\@/@/g' > $@
1123 6be8e2bf Iustin Pop
1124 55398706 Iustin Pop
man/%: man/%.in  $(REPLACE_VARS_SED)
1125 2ab2b9f5 Iustin Pop
	sed -f $(REPLACE_VARS_SED) < $< > $@
1126 f29266b4 Iustin Pop
1127 fc1282b8 Iustin Pop
epydoc.conf: epydoc.conf.in $(REPLACE_VARS_SED)
1128 fc1282b8 Iustin Pop
	sed -f $(REPLACE_VARS_SED) < $< > $@
1129 f774bd03 Michael Hanselmann
1130 84a12e40 Iustin Pop
vcs-version:
1131 84a12e40 Iustin Pop
	if test -d .git; then \
1132 84a12e40 Iustin Pop
	  git describe > $@; \
1133 84a12e40 Iustin Pop
	elif test ! -f $@ ; then \
1134 84a12e40 Iustin Pop
	  echo "Cannot auto-generate $@ file"; exit 1; \
1135 84a12e40 Iustin Pop
	fi
1136 84a12e40 Iustin Pop
1137 316dc1ff Iustin Pop
.PHONY: clean-vcs-version
1138 316dc1ff Iustin Pop
clean-vcs-version:
1139 316dc1ff Iustin Pop
	rm -f vcs-version
1140 316dc1ff Iustin Pop
1141 84a12e40 Iustin Pop
.PHONY: regen-vcs-version
1142 84a12e40 Iustin Pop
regen-vcs-version:
1143 e8230860 Michael Hanselmann
	set -e; \
1144 84a12e40 Iustin Pop
	cd $(srcdir); \
1145 84a12e40 Iustin Pop
	if test -d .git; then \
1146 b0b8458a Iustin Pop
	  $(MAKE) $(AM_MAKEFLAGS) clean-vcs-version; \
1147 b0b8458a Iustin Pop
	  $(MAKE) $(AM_MAKEFLAGS) vcs-version; \
1148 84a12e40 Iustin Pop
	fi
1149 84a12e40 Iustin Pop
1150 2997cb0a Iustin Pop
htools/Ganeti/Version.hs: htools/Ganeti/Version.hs.in \
1151 4c3d5fb6 Iustin Pop
	vcs-version $(built_base_sources)
1152 d6159933 Iustin Pop
	set -e; \
1153 d6159933 Iustin Pop
	VCSVER=`cat $(abs_top_srcdir)/vcs-version`; \
1154 d6159933 Iustin Pop
	sed -e "s/%ver%/$$VCSVER/" < $< > $@
1155 d6159933 Iustin Pop
1156 d99d1e36 Iustin Pop
htools/Ganeti/Constants.hs: htools/Ganeti/Constants.hs.in \
1157 f11e524b Iustin Pop
	lib/constants.py lib/_autoconf.py lib/luxi.py \
1158 4c3d5fb6 Iustin Pop
	$(CONVERT_CONSTANTS) $(built_base_sources) \
1159 ef958f2a Iustin Pop
	| lib/_vcsversion.py
1160 11fd5a86 Iustin Pop
	set -e; \
1161 876f6a5e Iustin Pop
	{ cat $< ; PYTHONPATH=. $(CONVERT_CONSTANTS); } > $@
1162 d99d1e36 Iustin Pop
1163 b88fcdd0 Iustin Pop
htest/Test/Ganeti/TestImports.hs: htest/Test/Ganeti/TestImports.hs.in \
1164 b88fcdd0 Iustin Pop
	$(built_base_sources)
1165 b88fcdd0 Iustin Pop
	set -e; \
1166 b88fcdd0 Iustin Pop
	{ cat $< ; \
1167 b88fcdd0 Iustin Pop
	  echo ; \
1168 b88fcdd0 Iustin Pop
	  for name in $(filter-out Ganeti.THH,$(subst /,.,$(patsubst %.hs,%,$(patsubst htools/%,%,$(HS_LIB_SRCS))))) ; do \
1169 b88fcdd0 Iustin Pop
	    echo "import $$name ()" ; \
1170 b88fcdd0 Iustin Pop
	  done ; \
1171 b88fcdd0 Iustin Pop
	} > $@
1172 b88fcdd0 Iustin Pop
1173 3735787e Iustin Pop
lib/_autoconf.py: Makefile | stamp-directories
1174 84a12e40 Iustin Pop
	set -e; \
1175 e8230860 Michael Hanselmann
	{ echo '# This file is automatically generated, do not edit!'; \
1176 e8230860 Michael Hanselmann
	  echo '#'; \
1177 67047322 Iustin Pop
	  echo ''; \
1178 67047322 Iustin Pop
	  echo '"""Build-time configuration for Ganeti.'; \
1179 67047322 Iustin Pop
	  echo '';\
1180 67047322 Iustin Pop
	  echo 'This file is autogenerated by the build process.'; \
1181 67047322 Iustin Pop
	  echo 'For any changes you need to re-run ./configure (and'; \
1182 67047322 Iustin Pop
	  echo 'not edit by hand).'; \
1183 67047322 Iustin Pop
	  echo ''; \
1184 67047322 Iustin Pop
	  echo '"""'; \
1185 67047322 Iustin Pop
	  echo ''; \
1186 55766d34 Andrea Spadaccini
	  echo '# pylint: disable=C0301,C0324'; \
1187 0a4e7f24 Iustin Pop
	  echo '# because this is autogenerated, we do not want'; \
1188 0a4e7f24 Iustin Pop
	  echo '# style warnings' ; \
1189 0a4e7f24 Iustin Pop
	  echo ''; \
1190 e8230860 Michael Hanselmann
	  echo "PACKAGE_VERSION = '$(PACKAGE_VERSION)'"; \
1191 e8230860 Michael Hanselmann
	  echo "VERSION_MAJOR = '$(VERSION_MAJOR)'"; \
1192 e8230860 Michael Hanselmann
	  echo "VERSION_MINOR = '$(VERSION_MINOR)'"; \
1193 e8230860 Michael Hanselmann
	  echo "VERSION_REVISION = '$(VERSION_REVISION)'"; \
1194 e8230860 Michael Hanselmann
	  echo "VERSION_SUFFIX = '$(VERSION_SUFFIX)'"; \
1195 e8230860 Michael Hanselmann
	  echo "VERSION_FULL = '$(VERSION_FULL)'"; \
1196 e8230860 Michael Hanselmann
	  echo "LOCALSTATEDIR = '$(localstatedir)'"; \
1197 e8230860 Michael Hanselmann
	  echo "SYSCONFDIR = '$(sysconfdir)'"; \
1198 553bd93f Vitaly Kuznetsov
	  echo "SSH_CONFIG_DIR = '$(SSH_CONFIG_DIR)'"; \
1199 052783ff Michael Hanselmann
	  echo "SSH_LOGIN_USER = '$(SSH_LOGIN_USER)'"; \
1200 052783ff Michael Hanselmann
	  echo "SSH_CONSOLE_USER = '$(SSH_CONSOLE_USER)'"; \
1201 e8230860 Michael Hanselmann
	  echo "EXPORT_DIR = '$(EXPORT_DIR)'"; \
1202 e8230860 Michael Hanselmann
	  echo "OS_SEARCH_PATH = [$(OS_SEARCH_PATH)]"; \
1203 2f2dbb4b Jun Futagawa
	  echo "XEN_BOOTLOADER = '$(XEN_BOOTLOADER)'"; \
1204 e8230860 Michael Hanselmann
	  echo "XEN_KERNEL = '$(XEN_KERNEL)'"; \
1205 e8230860 Michael Hanselmann
	  echo "XEN_INITRD = '$(XEN_INITRD)'"; \
1206 b8203e1e Iustin Pop
	  echo "KVM_KERNEL = '$(KVM_KERNEL)'"; \
1207 e8230860 Michael Hanselmann
	  echo "FILE_STORAGE_DIR = '$(FILE_STORAGE_DIR)'"; \
1208 cb7c0198 Iustin Pop
	  echo "ENABLE_FILE_STORAGE = $(ENABLE_FILE_STORAGE)"; \
1209 4b97f902 Apollon Oikonomopoulos
	  echo "SHARED_FILE_STORAGE_DIR = '$(SHARED_FILE_STORAGE_DIR)'"; \
1210 4b97f902 Apollon Oikonomopoulos
	  echo "ENABLE_SHARED_FILE_STORAGE = $(ENABLE_SHARED_FILE_STORAGE)"; \
1211 e8230860 Michael Hanselmann
	  echo "IALLOCATOR_SEARCH_PATH = [$(IALLOCATOR_SEARCH_PATH)]"; \
1212 7e2c5b9e Guido Trotter
	  echo "KVM_PATH = '$(KVM_PATH)'"; \
1213 c4dfb0b6 Andrea Spadaccini
	  echo "IP_PATH = '$(IP_PATH)'"; \
1214 fe5b0c42 Michael Hanselmann
	  echo "SOCAT_PATH = '$(SOCAT)'"; \
1215 fe5b0c42 Michael Hanselmann
	  echo "SOCAT_USE_ESCAPE = $(SOCAT_USE_ESCAPE)"; \
1216 e90739d6 Michael Hanselmann
	  echo "SOCAT_USE_COMPRESS = $(SOCAT_USE_COMPRESS)"; \
1217 bea60381 Michael Hanselmann
	  echo "LVM_STRIPECOUNT = $(LVM_STRIPECOUNT)"; \
1218 bea60381 Michael Hanselmann
	  echo "TOOLSDIR = '$(toolsdir)'"; \
1219 4f3d5b76 Michael Hanselmann
	  echo "GNT_SCRIPTS = [$(foreach i,$(notdir $(gnt_scripts)),'$(i)',)]"; \
1220 ada0e680 Iustin Pop
	  echo "HTOOLS_PROGS = [$(foreach i,$(HS_HTOOLS_PROGS),'$(i)',)]"; \
1221 f154a7a3 Michael Hanselmann
	  echo "PKGLIBDIR = '$(pkglibdir)'"; \
1222 8a69b3a8 Andrea Spadaccini
	  echo "DRBD_BARRIERS = '$(DRBD_BARRIERS)'"; \
1223 8a69b3a8 Andrea Spadaccini
	  echo "DRBD_NO_META_FLUSH = $(DRBD_NO_META_FLUSH)"; \
1224 551b6283 Iustin Pop
	  echo "SYSLOG_USAGE = '$(SYSLOG_USAGE)'"; \
1225 8b72b05c René Nussbaumer
	  echo "DAEMONS_GROUP = '$(DAEMONS_GROUP)'"; \
1226 f12e1736 René Nussbaumer
	  echo "ADMIN_GROUP = '$(ADMIN_GROUP)'"; \
1227 8b72b05c René Nussbaumer
	  echo "MASTERD_USER = '$(MASTERD_USER)'"; \
1228 f12e1736 René Nussbaumer
	  echo "MASTERD_GROUP = '$(MASTERD_GROUP)'"; \
1229 8b72b05c René Nussbaumer
	  echo "RAPI_USER = '$(RAPI_USER)'"; \
1230 f12e1736 René Nussbaumer
	  echo "RAPI_GROUP = '$(RAPI_GROUP)'"; \
1231 f12e1736 René Nussbaumer
	  echo "CONFD_USER = '$(CONFD_USER)'"; \
1232 f12e1736 René Nussbaumer
	  echo "CONFD_GROUP = '$(CONFD_GROUP)'"; \
1233 f12e1736 René Nussbaumer
	  echo "NODED_USER = '$(NODED_USER)'"; \
1234 03881cb0 René Nussbaumer
	  echo "NODED_GROUP = '$(NODED_GROUP)'"; \
1235 3536c792 Iustin Pop
	  echo "DISK_SEPARATOR = '$(DISK_SEPARATOR)'"; \
1236 a002ed79 Agata Murawska
	  echo "QEMUIMG_PATH = '$(QEMUIMG_PATH)'"; \
1237 e5395072 Iustin Pop
	  if [ "$(HTOOLS)" ]; then \
1238 e5395072 Iustin Pop
	    echo "HTOOLS = True"; \
1239 e5395072 Iustin Pop
	  else \
1240 e5395072 Iustin Pop
	    echo "HTOOLS = False"; \
1241 e5395072 Iustin Pop
	  fi; \
1242 cd8b0072 Iustin Pop
	  echo "ENABLE_CONFD = $(ENABLE_CONFD)"; \
1243 1eb37421 René Nussbaumer
	  echo "XEN_CMD = '$(XEN_CMD)'"; \
1244 42ab9ac4 Iustin Pop
	  echo "ENABLE_SPLIT_QUERY = $(ENABLE_SPLIT_QUERY)"; \
1245 e8230860 Michael Hanselmann
	} > $@
1246 e8230860 Michael Hanselmann
1247 3735787e Iustin Pop
lib/_vcsversion.py: Makefile vcs-version | stamp-directories
1248 13aeae6a Iustin Pop
	set -e; \
1249 13aeae6a Iustin Pop
	VCSVER=`cat $(abs_top_srcdir)/vcs-version`; \
1250 13aeae6a Iustin Pop
	{ echo '# This file is automatically generated, do not edit!'; \
1251 13aeae6a Iustin Pop
	  echo '#'; \
1252 13aeae6a Iustin Pop
	  echo ''; \
1253 13aeae6a Iustin Pop
	  echo '"""Build-time VCS version number for Ganeti.'; \
1254 13aeae6a Iustin Pop
	  echo '';\
1255 13aeae6a Iustin Pop
	  echo 'This file is autogenerated by the build process.'; \
1256 13aeae6a Iustin Pop
	  echo 'For any changes you need to re-run ./configure (and'; \
1257 13aeae6a Iustin Pop
	  echo 'not edit by hand).'; \
1258 13aeae6a Iustin Pop
	  echo ''; \
1259 13aeae6a Iustin Pop
	  echo '"""'; \
1260 13aeae6a Iustin Pop
	  echo ''; \
1261 55766d34 Andrea Spadaccini
	  echo '# pylint: disable=C0301,C0324'; \
1262 13aeae6a Iustin Pop
	  echo '# because this is autogenerated, we do not want'; \
1263 13aeae6a Iustin Pop
	  echo '# style warnings' ; \
1264 13aeae6a Iustin Pop
	  echo ''; \
1265 13aeae6a Iustin Pop
	  echo "VCS_VERSION = '$$VCSVER'"; \
1266 13aeae6a Iustin Pop
	} > $@
1267 13aeae6a Iustin Pop
1268 96a7481d Michael Hanselmann
lib/_generated_rpc.py: lib/rpc_defs.py $(BUILD_RPC)
1269 96a7481d Michael Hanselmann
	PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(BUILD_RPC) lib/rpc_defs.py > $@
1270 d5a2a550 Michael Hanselmann
1271 6e3bf290 Michael Hanselmann
$(SHELL_ENV_INIT): Makefile stamp-directories
1272 6e3bf290 Michael Hanselmann
	set -e; \
1273 6e3bf290 Michael Hanselmann
	{ echo '# Allow overriding for tests'; \
1274 6e3bf290 Michael Hanselmann
	  echo 'readonly LOCALSTATEDIR=$${LOCALSTATEDIR:-$${GANETI_ROOTDIR:-}$(localstatedir)}'; \
1275 6e3bf290 Michael Hanselmann
	  echo 'readonly SYSCONFDIR=$${SYSCONFDIR:-$${GANETI_ROOTDIR:-}$(sysconfdir)}'; \
1276 6e3bf290 Michael Hanselmann
	  echo; \
1277 6e3bf290 Michael Hanselmann
	  echo 'readonly PKGLIBDIR=$(pkglibdir)'; \
1278 6e3bf290 Michael Hanselmann
	  echo 'readonly LOG_DIR="$$LOCALSTATEDIR/log/ganeti"'; \
1279 6e3bf290 Michael Hanselmann
	  echo 'readonly RUN_DIR="$$LOCALSTATEDIR/run/ganeti"'; \
1280 6e3bf290 Michael Hanselmann
	  echo 'readonly DATA_DIR="$$LOCALSTATEDIR/lib/ganeti"'; \
1281 6e3bf290 Michael Hanselmann
	  echo 'readonly CONF_DIR="$$SYSCONFDIR/ganeti"'; \
1282 6e3bf290 Michael Hanselmann
	} > $@
1283 6e3bf290 Michael Hanselmann
1284 6e3bf290 Michael Hanselmann
$(REPLACE_VARS_SED): $(SHELL_ENV_INIT) Makefile stamp-directories
1285 e8230860 Michael Hanselmann
	set -e; \
1286 e8230860 Michael Hanselmann
	{ echo 's#@PREFIX@#$(prefix)#g'; \
1287 e8230860 Michael Hanselmann
	  echo 's#@SYSCONFDIR@#$(sysconfdir)#g'; \
1288 e8230860 Michael Hanselmann
	  echo 's#@LOCALSTATEDIR@#$(localstatedir)#g'; \
1289 7a2ba406 Luca Bigliardi
	  echo 's#@BINDIR@#$(bindir)#g'; \
1290 e8230860 Michael Hanselmann
	  echo 's#@SBINDIR@#$(sbindir)#g'; \
1291 e8230860 Michael Hanselmann
	  echo 's#@GANETI_VERSION@#$(PACKAGE_VERSION)#g'; \
1292 2f2dbb4b Jun Futagawa
	  echo 's#@CUSTOM_XEN_BOOTLOADER@#$(XEN_BOOTLOADER)#g'; \
1293 e8230860 Michael Hanselmann
	  echo 's#@CUSTOM_XEN_KERNEL@#$(XEN_KERNEL)#g'; \
1294 e8230860 Michael Hanselmann
	  echo 's#@CUSTOM_XEN_INITRD@#$(XEN_INITRD)#g'; \
1295 56956bcb Iustin Pop
	  echo 's#@CUSTOM_IALLOCATOR_SEARCH_PATH@#$(IALLOCATOR_SEARCH_PATH)#g'; \
1296 56956bcb Iustin Pop
	  echo 's#@CUSTOM_EXPORT_DIR@#$(EXPORT_DIR)#g'; \
1297 d3b4cf9f Iustin Pop
	  echo 's#@RPL_FILE_STORAGE_DIR@#$(FILE_STORAGE_DIR)#g'; \
1298 7e1fac25 Michael Hanselmann
	  echo 's#@RPL_SSH_INITD_SCRIPT@#$(SSH_INITD_SCRIPT)#g'; \
1299 c5159571 Iustin Pop
	  echo 's#@PKGLIBDIR@#$(pkglibdir)#g'; \
1300 0d150c50 René Nussbaumer
	  echo 's#@GNTMASTERUSER@#$(MASTERD_USER)#g'; \
1301 0d150c50 René Nussbaumer
	  echo 's#@GNTRAPIUSER@#$(RAPI_USER)#g'; \
1302 0d150c50 René Nussbaumer
	  echo 's#@GNTCONFDUSER@#$(CONFD_USER)#g'; \
1303 0d150c50 René Nussbaumer
	  echo 's#@GNTNODEDUSER@#$(NODED_USER)#g'; \
1304 0d150c50 René Nussbaumer
	  echo 's#@GNTRAPIGROUP@#$(RAPI_GROUP)#g'; \
1305 0d150c50 René Nussbaumer
	  echo 's#@GNTADMINGROUP@#$(ADMIN_GROUP)#g'; \
1306 0d150c50 René Nussbaumer
	  echo 's#@GNTCONFDGROUP@#$(CONFD_GROUP)#g'; \
1307 0d150c50 René Nussbaumer
	  echo 's#@GNTMASTERDGROUP@#$(MASTERD_GROUP)#g'; \
1308 46a8da3b René Nussbaumer
	  echo 's#@GNTDAEMONSGROUP@#$(DAEMONS_GROUP)#g'; \
1309 cd8b0072 Iustin Pop
	  echo 's#@CUSTOM_ENABLE_CONFD@#$(ENABLE_CONFD)#g'; \
1310 fc1282b8 Iustin Pop
	  echo 's#@MODULES@#$(strip $(lint_python_code))#g'; \
1311 42ab9ac4 Iustin Pop
	  echo 's#@ENABLE_SPLIT_QUERY@#$(ENABLE_SPLIT_QUERY)#g'; \
1312 6e3bf290 Michael Hanselmann
	  echo; \
1313 6e3bf290 Michael Hanselmann
	  echo '/^@SHELL_ENV_INIT@$$/ {'; \
1314 6e3bf290 Michael Hanselmann
	  echo '  r $(SHELL_ENV_INIT)'; \
1315 6e3bf290 Michael Hanselmann
	  echo '  d'; \
1316 6e3bf290 Michael Hanselmann
	  echo '}'; \
1317 e8230860 Michael Hanselmann
	} > $@
1318 e8230860 Michael Hanselmann
1319 67313146 Michael Hanselmann
# Using deferred evaluation
1320 899c4d2c Michael Hanselmann
daemons/ganeti-%: MODULE = ganeti.server.$(patsubst ganeti-%,%,$(notdir $@))
1321 9f4bb951 Michael Hanselmann
daemons/ganeti-watcher: MODULE = ganeti.watcher
1322 67313146 Michael Hanselmann
scripts/%: MODULE = ganeti.client.$(subst -,_,$(notdir $@))
1323 0d2bf835 René Nussbaumer
tools/ensure-dirs: MODULE = ganeti.tools.ensure_dirs
1324 189b51fa Iustin Pop
$(HS_BUILT_TEST_HELPERS): TESTROLE = $(patsubst htest/%,%,$@)
1325 67313146 Michael Hanselmann
1326 3735787e Iustin Pop
$(PYTHON_BOOTSTRAP): Makefile | stamp-directories
1327 67313146 Michael Hanselmann
	test -n "$(MODULE)" || { echo Missing module; exit 1; }
1328 2d48a3a2 Michael Hanselmann
	set -e; \
1329 d75e738e Michael Hanselmann
	{ echo '#!/usr/bin/python'; \
1330 2d48a3a2 Michael Hanselmann
	  echo '# This file is automatically generated, do not edit!'; \
1331 67313146 Michael Hanselmann
	  echo "# Edit $(MODULE) instead."; \
1332 2d48a3a2 Michael Hanselmann
	  echo; \
1333 67313146 Michael Hanselmann
	  echo '"""Bootstrap script for L{$(MODULE)}"""'; \
1334 2d48a3a2 Michael Hanselmann
	  echo; \
1335 55766d34 Andrea Spadaccini
	  echo '# pylint: disable=C0103'; \
1336 2d48a3a2 Michael Hanselmann
	  echo '# C0103: Invalid name'; \
1337 2d48a3a2 Michael Hanselmann
	  echo; \
1338 2d48a3a2 Michael Hanselmann
	  echo 'import sys'; \
1339 67313146 Michael Hanselmann
	  echo 'import $(MODULE) as main'; \
1340 2d48a3a2 Michael Hanselmann
	  echo; \
1341 2d48a3a2 Michael Hanselmann
	  echo '# Temporarily alias commands until bash completion'; \
1342 2d48a3a2 Michael Hanselmann
	  echo '# generator is changed'; \
1343 67313146 Michael Hanselmann
	  echo 'if hasattr(main, "commands"):'; \
1344 55766d34 Andrea Spadaccini
	  echo '  commands = main.commands # pylint: disable=E1101'; \
1345 3f42b4f6 Michael Hanselmann
	  echo 'if hasattr(main, "aliases"):'; \
1346 55766d34 Andrea Spadaccini
	  echo '  aliases = main.aliases # pylint: disable=E1101'; \
1347 2d48a3a2 Michael Hanselmann
	  echo; \
1348 2d48a3a2 Michael Hanselmann
	  echo 'if __name__ == "__main__":'; \
1349 67313146 Michael Hanselmann
	  echo '  sys.exit(main.Main())'; \
1350 2d48a3a2 Michael Hanselmann
	} > $@
1351 2d48a3a2 Michael Hanselmann
	chmod u+x $@
1352 2d48a3a2 Michael Hanselmann
1353 3096524e Iustin Pop
$(HS_BUILT_TEST_HELPERS): Makefile
1354 3096524e Iustin Pop
	@test -n "$(TESTROLE)" || { echo Missing TESTROLE; exit 1; }
1355 3096524e Iustin Pop
	set -e; \
1356 3096524e Iustin Pop
	{ echo '#!/bin/sh'; \
1357 3096524e Iustin Pop
	  echo '# This file is automatically generated, do not edit!'; \
1358 3096524e Iustin Pop
	  echo "# Edit Makefile.am instead."; \
1359 3096524e Iustin Pop
	  echo; \
1360 f0f3a6df Iustin Pop
	  echo "HTOOLS=$(TESTROLE) exec ./htest/hpc-htools \"\$$@\""; \
1361 3096524e Iustin Pop
	} > $@
1362 3096524e Iustin Pop
	chmod u+x $@
1363 3096524e Iustin Pop
1364 3735787e Iustin Pop
stamp-directories: Makefile
1365 924ecd85 Iustin Pop
	$(MAKE) $(AM_MAKEFLAGS) ganeti
1366 3735787e Iustin Pop
	@mkdir_p@ $(DIRS) $(BUILDTIME_DIR_AUTOCREATE)
1367 3735787e Iustin Pop
	touch $@
1368 3735787e Iustin Pop
1369 e8230860 Michael Hanselmann
# We need to create symlinks because "make distcheck" will not install Python
1370 e8230860 Michael Hanselmann
# files when building.
1371 3735787e Iustin Pop
stamp-srclinks: Makefile | stamp-directories
1372 e8230860 Michael Hanselmann
	set -e; \
1373 01a3a718 Michael Hanselmann
	for i in $(srclink_files); do \
1374 e8230860 Michael Hanselmann
		if test ! -f $$i -a -f $(abs_top_srcdir)/$$i; then \
1375 e8230860 Michael Hanselmann
			$(LN_S) $(abs_top_srcdir)/$$i $$i; \
1376 e8230860 Michael Hanselmann
		fi; \
1377 e8230860 Michael Hanselmann
	done
1378 dd1dfd9a Michael Hanselmann
	touch $@
1379 97a37b3f Michael Hanselmann
1380 9ff7e35c Michael Hanselmann
.PHONY: ganeti
1381 9ff7e35c Michael Hanselmann
ganeti:
1382 01f3e7b1 Iustin Pop
	cd $(top_builddir) && test -h "$@" || { rm -f $@ && $(LN_S) lib $@; }
1383 9ff7e35c Michael Hanselmann
1384 6b997854 Michael Hanselmann
.PHONY: check-dirs
1385 4c3d5fb6 Iustin Pop
check-dirs: $(GENERATED_FILES)
1386 0c1103d6 Iustin Pop
	@set -e; \
1387 6b997854 Michael Hanselmann
	find . -type d \( \( -name . \) -o \( \
1388 6b997854 Michael Hanselmann
		-name .git -o \
1389 6b997854 Michael Hanselmann
		-name autom4te.cache \
1390 6b997854 Michael Hanselmann
		\) -prune -o -print \) | { \
1391 6b997854 Michael Hanselmann
		error=; \
1392 6b997854 Michael Hanselmann
		while read dir; do \
1393 6b997854 Michael Hanselmann
			case "$$dir" in \
1394 6b997854 Michael Hanselmann
				$(strip $(patsubst %,(./%) ;;,$(DIRCHECK_EXCLUDE) $(DIRS))) \
1395 6b997854 Michael Hanselmann
				*) error=1; echo "Directory $$dir not listed in Makefile" >&2 ;; \
1396 6b997854 Michael Hanselmann
			esac; \
1397 6b997854 Michael Hanselmann
		done; \
1398 6b997854 Michael Hanselmann
		for dir in $(DIRS); do \
1399 6b997854 Michael Hanselmann
			if ! test -d "$$dir"; then \
1400 6b997854 Michael Hanselmann
				echo "Directory $$dir listed in DIRS does not exist" >&2; \
1401 6b997854 Michael Hanselmann
				error=1; \
1402 6b997854 Michael Hanselmann
			fi \
1403 6b997854 Michael Hanselmann
		done; \
1404 6b997854 Michael Hanselmann
		if test -n "$$error"; then exit 1; else exit 0; fi; \
1405 6b997854 Michael Hanselmann
	}
1406 6b997854 Michael Hanselmann
1407 f6cbcc06 Michael Hanselmann
.PHONY: check-local
1408 4c3d5fb6 Iustin Pop
check-local: check-dirs $(GENERATED_FILES)
1409 eed5c5df Michael Hanselmann
	$(CHECK_PYTHON_CODE) $(check_python_code)
1410 5d3c30df Michael Hanselmann
	PYTHONPATH=. $(CHECK_HEADER) $(check_python_code)
1411 35576615 Michael Hanselmann
	$(CHECK_VERSION) $(VERSION) $(top_srcdir)/NEWS
1412 7385c51d Michael Hanselmann
	$(CHECK_NEWS) < $(top_srcdir)/NEWS
1413 83ea5145 Michael Hanselmann
	PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(CHECK_IMPORTS) . $(standalone_python_modules)
1414 dad26941 Iustin Pop
	@expver=$(VERSION_MAJOR).$(VERSION_MINOR); \
1415 154d7ba5 Michael Hanselmann
	if test "`head -n 1 $(top_srcdir)/README`" != "Ganeti $$expver"; then \
1416 9488fd1d Michael Hanselmann
		echo "Incorrect version in README, expected $$expver"; \
1417 9488fd1d Michael Hanselmann
		exit 1; \
1418 7ecb3d0e Michael Hanselmann
	fi; \
1419 ab171697 Michael Hanselmann
	for file in doc/iallocator.rst doc/hooks.rst doc/virtual-cluster.rst; do \
1420 d5114fa1 Michael Hanselmann
		if test "`sed -ne '4 p' $(top_srcdir)/$$file`" != \
1421 9822b1dd Iustin Pop
			"Documents Ganeti version $$expver"; then \
1422 d5114fa1 Michael Hanselmann
			echo "Incorrect version in $$file, expected $$expver"; \
1423 d5114fa1 Michael Hanselmann
			exit 1; \
1424 d5114fa1 Michael Hanselmann
		fi; \
1425 d5114fa1 Michael Hanselmann
	done
1426 eed5c5df Michael Hanselmann
1427 49e11c49 Iustin Pop
.PHONY: hs-check
1428 f0f3a6df Iustin Pop
hs-check: htest/test htest/hpc-htools $(HS_BUILT_TEST_HELPERS)
1429 49e11c49 Iustin Pop
	@rm -f test.tix
1430 f0f3a6df Iustin Pop
	./htest/test
1431 f0f3a6df Iustin Pop
	HBINARY="./htest/hpc-htools" ./htest/offline-test.sh
1432 49e11c49 Iustin Pop
1433 08366664 Michael Hanselmann
# E111: indentation is not a multiple of four
1434 5ae4945a Iustin Pop
# E121: continuation line indentation is not a multiple of four
1435 5ae4945a Iustin Pop
#       (since our indent level is not 4)
1436 5ae4945a Iustin Pop
# E125: continuation line does not distinguish itself from next logical line
1437 5ae4945a Iustin Pop
#       (since our indent level is not 4)
1438 5ae4945a Iustin Pop
# E127: continuation line over-indented for visual indent
1439 5ae4945a Iustin Pop
#       (since our indent level is not 4)
1440 5ae4945a Iustin Pop
# note: do NOT add E128 here; it's a valid style error in most cases!
1441 5ae4945a Iustin Pop
# I've seen real errors, but also some cases were we indent wrongly
1442 5ae4945a Iustin Pop
# due to line length; try to rework the cases where it is triggered,
1443 5ae4945a Iustin Pop
# instead of silencing it
1444 08366664 Michael Hanselmann
# E261: at least two spaces before inline comment
1445 08366664 Michael Hanselmann
# E501: line too long (80 characters)
1446 5ae4945a Iustin Pop
PEP8_IGNORE = E111,E121,E125,E127,E261,E501
1447 08366664 Michael Hanselmann
1448 08366664 Michael Hanselmann
# For excluding pep8 expects filenames only, not whole paths
1449 08366664 Michael Hanselmann
PEP8_EXCLUDE = $(subst $(space),$(comma),$(strip $(notdir $(BUILT_PYTHON_SOURCES))))
1450 08366664 Michael Hanselmann
1451 6e4c8f68 Iustin Pop
LINT_TARGETS = pylint pylint-qa
1452 6e4c8f68 Iustin Pop
if HAS_PEP8
1453 6e4c8f68 Iustin Pop
LINT_TARGETS += pep8
1454 6e4c8f68 Iustin Pop
endif
1455 6e4c8f68 Iustin Pop
if HAS_HLINT
1456 6e4c8f68 Iustin Pop
LINT_TARGETS += hlint
1457 6e4c8f68 Iustin Pop
endif
1458 6e4c8f68 Iustin Pop
1459 e0098923 Iustin Pop
.PHONY: lint
1460 6e4c8f68 Iustin Pop
lint: $(LINT_TARGETS)
1461 6e4c8f68 Iustin Pop
1462 6e4c8f68 Iustin Pop
.PHONY: pylint
1463 4c3d5fb6 Iustin Pop
pylint: $(GENERATED_FILES)
1464 6d7cc5ff Michael Hanselmann
	@test -n "$(PYLINT)" || { echo 'pylint' not found during configure; exit 1; }
1465 6d7cc5ff Michael Hanselmann
	$(PYLINT) $(LINT_OPTS) $(lint_python_code)
1466 6e4c8f68 Iustin Pop
1467 6e4c8f68 Iustin Pop
.PHONY: pylint-qa
1468 4c3d5fb6 Iustin Pop
pylint-qa: $(GENERATED_FILES)
1469 6e4c8f68 Iustin Pop
	@test -n "$(PYLINT)" || { echo 'pylint' not found during configure; exit 1; }
1470 3582eef6 Iustin Pop
	cd $(top_srcdir)/qa && \
1471 3582eef6 Iustin Pop
	  PYTHONPATH=$(abs_top_srcdir) $(PYLINT) $(LINT_OPTS) \
1472 3582eef6 Iustin Pop
	  --rcfile  ../pylintrc $(patsubst qa/%.py,%,$(qa_scripts))
1473 e0098923 Iustin Pop
1474 6e4c8f68 Iustin Pop
.PHONY: pep8
1475 4c3d5fb6 Iustin Pop
pep8: $(GENERATED_FILES)
1476 6e4c8f68 Iustin Pop
	@test -n "$(PEP8)" || { echo 'pep8' not found during configure; exit 1; }
1477 6e4c8f68 Iustin Pop
	$(PEP8) --ignore='$(PEP8_IGNORE)' --exclude='$(PEP8_EXCLUDE)' \
1478 6e4c8f68 Iustin Pop
		--repeat $(pep8_python_code)
1479 6e4c8f68 Iustin Pop
1480 2cdaf225 Iustin Pop
# FIXME: remove ignore "Use void" when GHC 6.x is deprecated
1481 191ff68c Iustin Pop
.PHONY: hlint
1482 5a1e31b4 Iustin Pop
hlint: $(HS_BUILT_SRCS) htools/lint-hints.hs
1483 6e4c8f68 Iustin Pop
	@test -n "$(HLINT)" || { echo 'hlint' not found during configure; exit 1; }
1484 191ff68c Iustin Pop
	if tty -s; then C="-c"; else C=""; fi; \
1485 6e4c8f68 Iustin Pop
	$(HLINT) --report=doc/hs-lint.html --cross $$C \
1486 3603605a Iustin Pop
	  --ignore "Use first" \
1487 3603605a Iustin Pop
	  --ignore "Use comparing" \
1488 3603605a Iustin Pop
	  --ignore "Use on" \
1489 3603605a Iustin Pop
	  --ignore "Reduce duplication" \
1490 2cdaf225 Iustin Pop
	  --ignore "Use &&&" \
1491 2cdaf225 Iustin Pop
	  --ignore "Use void" \
1492 5a1e31b4 Iustin Pop
	  --hint htools/lint-hints \
1493 51309138 Iustin Pop
	  $(filter-out htools/Ganeti/THH.hs,$(HS_LIBTEST_SRCS))
1494 191ff68c Iustin Pop
1495 84a12e40 Iustin Pop
# a dist hook rule for updating the vcs-version file; this is
1496 84a12e40 Iustin Pop
# hardcoded due to where it needs to build the file...
1497 84a12e40 Iustin Pop
dist-hook:
1498 b0b8458a Iustin Pop
	$(MAKE) $(AM_MAKEFLAGS) regen-vcs-version
1499 316dc1ff Iustin Pop
	rm -f $(top_distdir)/vcs-version
1500 84a12e40 Iustin Pop
	cp -p $(srcdir)/vcs-version $(top_distdir)
1501 84a12e40 Iustin Pop
1502 84a12e40 Iustin Pop
# a distcheck hook rule for catching revision control directories
1503 b6f2e47f Iustin Pop
distcheck-hook:
1504 c6aa0c42 Michael Hanselmann
	if find $(top_distdir) -name .svn -or -name .git | grep .; then \
1505 c6aa0c42 Michael Hanselmann
		echo "Found revision control files in final archive." 1>&2; \
1506 c6aa0c42 Michael Hanselmann
		exit 1; \
1507 c6aa0c42 Michael Hanselmann
	fi
1508 c6aa0c42 Michael Hanselmann
	if find $(top_distdir) -name '*.py[co]' | grep .; then \
1509 c6aa0c42 Michael Hanselmann
		echo "Found Python byte code in final archive." 1>&2; \
1510 c6aa0c42 Michael Hanselmann
		exit 1; \
1511 c6aa0c42 Michael Hanselmann
	fi
1512 c6aa0c42 Michael Hanselmann
	if find $(top_distdir) -name '*~' | grep .; then \
1513 c6aa0c42 Michael Hanselmann
		echo "Found backup files in final archive." 1>&2; \
1514 b6f2e47f Iustin Pop
		exit 1; \
1515 b6f2e47f Iustin Pop
	fi
1516 bf0b21da Michael Hanselmann
# Empty files or directories should not be distributed. They can cause
1517 bf0b21da Michael Hanselmann
# unnecessary warnings for packagers. Directories used by automake during
1518 bf0b21da Michael Hanselmann
# distcheck must be excluded.
1519 bf0b21da Michael Hanselmann
	if find $(top_distdir) -empty -and -not \( \
1520 bf0b21da Michael Hanselmann
			-path $(top_distdir)/_build -or \
1521 bf0b21da Michael Hanselmann
			-path $(top_distdir)/_inst \) | grep .; then \
1522 bf0b21da Michael Hanselmann
		echo "Found empty files or directories in final archive." 1>&2; \
1523 bf0b21da Michael Hanselmann
		exit 1; \
1524 bf0b21da Michael Hanselmann
	fi
1525 c7b86f6c Michael Hanselmann
	if test -n "$(BUILD_RELEASE)" && \
1526 c7b86f6c Michael Hanselmann
	   grep -n -H -E '^\*.*unreleased' $(top_distdir)/NEWS; then \
1527 c7b86f6c Michael Hanselmann
		echo "Found unreleased version in NEWS." >&2; \
1528 c7b86f6c Michael Hanselmann
		exit 1; \
1529 c7b86f6c Michael Hanselmann
	fi
1530 c7b86f6c Michael Hanselmann
1531 c7b86f6c Michael Hanselmann
# When building a release, stricter checks should be used
1532 e627fe09 Michael Hanselmann
distcheck-release dist-release: export BUILD_RELEASE = 1
1533 c7b86f6c Michael Hanselmann
distcheck-release: distcheck
1534 b6f2e47f Iustin Pop
1535 7213dded René Nussbaumer
distrebuildcheck: dist
1536 7213dded René Nussbaumer
	set -e; \
1537 7213dded René Nussbaumer
	builddir=$$(mktemp -d $(abs_srcdir)/distrebuildcheck.XXXXXXX); \
1538 7213dded René Nussbaumer
	trap "echo Removing $$builddir; cd $(abs_srcdir); rm -rf $$builddir" EXIT; \
1539 7213dded René Nussbaumer
	cd $$builddir; \
1540 7213dded René Nussbaumer
	tar xzf $(abs_srcdir)/$(distdir).tar.gz; \
1541 7213dded René Nussbaumer
	cd $(distdir); \
1542 7213dded René Nussbaumer
	./configure; \
1543 7213dded René Nussbaumer
	$(MAKE) maintainer-clean; \
1544 7213dded René Nussbaumer
	cp $(abs_srcdir)/vcs-version .; \
1545 7213dded René Nussbaumer
	./configure; \
1546 7213dded René Nussbaumer
	$(MAKE) $(AM_MAKEFLAGS)
1547 7213dded René Nussbaumer
1548 e627fe09 Michael Hanselmann
dist-release: dist
1549 e627fe09 Michael Hanselmann
	set -e; \
1550 e627fe09 Michael Hanselmann
	for i in $(DIST_ARCHIVES); do \
1551 e627fe09 Michael Hanselmann
		echo -n "Checking $$i ... "; \
1552 e627fe09 Michael Hanselmann
		autotools/check-tar < $$i; \
1553 e627fe09 Michael Hanselmann
		echo OK; \
1554 e627fe09 Michael Hanselmann
	done
1555 e627fe09 Michael Hanselmann
1556 8925faaa Iustin Pop
install-exec-local:
1557 0d93b082 Michael Hanselmann
	@mkdir_p@ "$(DESTDIR)${localstatedir}/lib/ganeti" \
1558 2fa9f1dd Michael Hanselmann
	  "$(DESTDIR)${localstatedir}/log/ganeti" \
1559 2fa9f1dd Michael Hanselmann
	  "$(DESTDIR)${localstatedir}/run/ganeti"
1560 e8230860 Michael Hanselmann
1561 d128fdb6 Iustin Pop
.PHONY: apidoc
1562 a38bfce5 Iustin Pop
if WANT_HTOOLSAPIDOC
1563 a38bfce5 Iustin Pop
apidoc: py-apidoc hs-apidoc
1564 a38bfce5 Iustin Pop
else
1565 a38bfce5 Iustin Pop
apidoc: py-apidoc
1566 a38bfce5 Iustin Pop
endif
1567 a38bfce5 Iustin Pop
1568 a38bfce5 Iustin Pop
.PHONY: py-apidoc
1569 4c3d5fb6 Iustin Pop
py-apidoc: epydoc.conf $(RUN_IN_TEMPDIR) $(GENERATED_FILES)
1570 b959138f Michael Hanselmann
	$(RUN_IN_TEMPDIR) epydoc -v \
1571 b959138f Michael Hanselmann
		--conf $(CURDIR)/epydoc.conf \
1572 22c5390d Iustin Pop
		--output $(CURDIR)/$(APIDOC_PY_DIR)
1573 a38bfce5 Iustin Pop
1574 a38bfce5 Iustin Pop
.PHONY: hs-apidoc
1575 c3f67183 Iustin Pop
hs-apidoc: $(HS_BUILT_SRCS)
1576 a38bfce5 Iustin Pop
	@test -n "$(HSCOLOUR)" || \
1577 a38bfce5 Iustin Pop
	    { echo 'HsColour' not found during configure; exit 1; }
1578 a38bfce5 Iustin Pop
	@test -n "$(HADDOCK)" || \
1579 a38bfce5 Iustin Pop
	    { echo 'haddock' not found during configure; exit 1; }
1580 22c5390d Iustin Pop
	rm -rf $(APIDOC_HS_DIR)/*
1581 458a286a Iustin Pop
	@mkdir_p@ $(APIDOC_HS_DIR)/Ganeti/HTools/Program
1582 358a0a8f Iustin Pop
	@mkdir_p@ $(APIDOC_HS_DIR)/Ganeti/Confd
1583 4cbe9bda Iustin Pop
	@mkdir_p@ $(APIDOC_HS_DIR)/Ganeti/Query
1584 22c5390d Iustin Pop
	$(HSCOLOUR) -print-css > $(APIDOC_HS_DIR)/Ganeti/hscolour.css
1585 82888134 Michael Hanselmann
	$(LN_S) ../hscolour.css $(APIDOC_HS_DIR)/Ganeti/HTools/hscolour.css
1586 358a0a8f Iustin Pop
	$(LN_S) ../hscolour.css $(APIDOC_HS_DIR)/Ganeti/Confd/hscolour.css
1587 a38bfce5 Iustin Pop
	set -e ; \
1588 a38bfce5 Iustin Pop
	cd htools; \
1589 c478f837 Iustin Pop
	if [ "$(HTOOLS_NOCURL)" ]; \
1590 c478f837 Iustin Pop
	then OPTGHC="--optghc=$(HTOOLS_NOCURL)"; \
1591 c478f837 Iustin Pop
	else OPTGHC=""; \
1592 c478f837 Iustin Pop
	fi; \
1593 1adec4be Iustin Pop
	if [ "$(HTOOLS_PARALLEL3)" ]; \
1594 1adec4be Iustin Pop
	then OPTGHC="$$OPTGHC --optghc=$(HTOOLS_PARALLEL3)"; \
1595 1adec4be Iustin Pop
	fi; \
1596 b88fcdd0 Iustin Pop
	RELSRCS="$(HS_LIB_SRCS:htools/%=%) $(patsubst htools/%,%,$(filter htools/%,$(HS_BUILT_SRCS)))"; \
1597 a38bfce5 Iustin Pop
	for file in $$RELSRCS; do \
1598 a38bfce5 Iustin Pop
		hfile=`echo $$file|sed 's/\\.hs$$//'`.html; \
1599 22c5390d Iustin Pop
		$(HSCOLOUR) -css -anchor $$file > ../$(APIDOC_HS_DIR)/$$hfile ; \
1600 a38bfce5 Iustin Pop
	done ; \
1601 22c5390d Iustin Pop
	$(HADDOCK) --odir ../$(APIDOC_HS_DIR) --html --ignore-all-exports -w \
1602 a38bfce5 Iustin Pop
		-t ganeti-htools -p haddock-prologue \
1603 a38bfce5 Iustin Pop
		--source-module="%{MODULE/.//}.html" \
1604 a38bfce5 Iustin Pop
		--source-entity="%{MODULE/.//}.html#%{NAME}" \
1605 c478f837 Iustin Pop
		$$OPTGHC \
1606 c3f67183 Iustin Pop
		$(filter-out Ganeti/HTools/ExtLoader.hs,$(HS_LIB_SRCS:htools/%=%))
1607 d128fdb6 Iustin Pop
1608 13e720f1 Iustin Pop
.PHONY: TAGS
1609 4c3d5fb6 Iustin Pop
TAGS: $(GENERATED_FILES)
1610 13e720f1 Iustin Pop
	rm -f TAGS
1611 6b84f036 Iustin Pop
	$(GHC) -e ":etags" -v0 \
1612 6b84f036 Iustin Pop
	  $(filter-out -O -Werror,$(HFLAGS)) \
1613 6b84f036 Iustin Pop
	  $(HTOOLS_NOCURL) $(HTOOLS_PARALLEL3) \
1614 6b84f036 Iustin Pop
	  $(HS_LIBTEST_SRCS)
1615 74fa8200 Iustin Pop
	find . -path './lib/*.py' -o -path './scripts/gnt-*' -o \
1616 74fa8200 Iustin Pop
	  -path './daemons/ganeti-*' -o -path './tools/*' -o \
1617 74fa8200 Iustin Pop
	  -path './qa/*.py' | \
1618 2db53645 Iustin Pop
	  etags -l python -a -
1619 13e720f1 Iustin Pop
1620 27e336af Michael Hanselmann
.PHONY: coverage
1621 b91e9518 Iustin Pop
if WANT_HTOOLS
1622 b91e9518 Iustin Pop
coverage: py-coverage hs-coverage
1623 b91e9518 Iustin Pop
else
1624 b91e9518 Iustin Pop
coverage: py-coverage
1625 b91e9518 Iustin Pop
endif
1626 b91e9518 Iustin Pop
1627 b91e9518 Iustin Pop
.PHONY: py-coverage
1628 4c3d5fb6 Iustin Pop
py-coverage: $(GENERATED_FILES) $(python_tests)
1629 27e336af Michael Hanselmann
	set -e; \
1630 22c5390d Iustin Pop
	COVERAGE_FILE=$(CURDIR)/$(COVERAGE_PY_DIR)/data \
1631 22c5390d Iustin Pop
	TEXT_COVERAGE=$(CURDIR)/$(COVERAGE_PY_DIR)/report.txt \
1632 22c5390d Iustin Pop
	HTML_COVERAGE=$(CURDIR)/$(COVERAGE_PY_DIR) \
1633 e8c8cf1a Michael Hanselmann
	$(PLAIN_TESTS_ENVIRONMENT) $(abs_top_srcdir)/autotools/gen-coverage \
1634 e8c8cf1a Michael Hanselmann
	$(python_tests)
1635 27e336af Michael Hanselmann
1636 b91e9518 Iustin Pop
.PHONY: hs-coverage
1637 f0f3a6df Iustin Pop
hs-coverage: $(haskell_tests) htest/hpc-htools
1638 316dc1ff Iustin Pop
	rm -f *.tix
1639 b0b8458a Iustin Pop
	$(MAKE) $(AM_MAKEFLAGS) hs-check
1640 48f12e73 Iustin Pop
	@mkdir_p@ $(COVERAGE_HS_DIR)
1641 96eccc1f Iustin Pop
	hpc combine --union $(HPCEXCL) \
1642 96eccc1f Iustin Pop
	  test.tix hpc-htools.tix > coverage-htools.tix
1643 896b2850 Iustin Pop
	hpc markup --destdir=$(COVERAGE_HS_DIR) coverage-htools.tix
1644 896b2850 Iustin Pop
	hpc report coverage-htools.tix
1645 82888134 Michael Hanselmann
	$(LN_S) -f hpc_index.html $(COVERAGE_HS_DIR)/index.html
1646 b91e9518 Iustin Pop
1647 ec8379bd Iustin Pop
# Special "kind-of-QA" target for htools, needs special setup (all
1648 ec8379bd Iustin Pop
# tools compiled with -fhpc)
1649 ec8379bd Iustin Pop
.PHONY: live-test
1650 ec8379bd Iustin Pop
live-test: all
1651 ec8379bd Iustin Pop
	set -e ; \
1652 ec8379bd Iustin Pop
	cd htools; \
1653 82888134 Michael Hanselmann
	rm -f .hpc; $(LN_S) ../.hpc .hpc; \
1654 ec8379bd Iustin Pop
	rm -f *.tix *.mix; \
1655 ec8379bd Iustin Pop
	./live-test.sh; \
1656 c3f67183 Iustin Pop
	hpc sum --union $(HPCEXCL) $(addsuffix .tix,$(HS_PROGS:htools/%=%)) \
1657 ec8379bd Iustin Pop
	  --output=live-test.tix ; \
1658 22c5390d Iustin Pop
	@mkdir_p@ ../$(COVERAGE_HS_DIR) ; \
1659 22c5390d Iustin Pop
	hpc markup --destdir=../$(COVERAGE_HS_DIR) live-test \
1660 ec8379bd Iustin Pop
		--srcdir=.. $(HPCEXCL) ; \
1661 ec8379bd Iustin Pop
	hpc report --srcdir=.. live-test $(HPCEXCL)
1662 b91e9518 Iustin Pop
1663 b341b9ca Guido Trotter
commit-check: distcheck lint apidoc
1664 b341b9ca Guido Trotter
1665 6438e259 Iustin Pop
.PHONY: gitignore-check
1666 6438e259 Iustin Pop
gitignore-check:
1667 6438e259 Iustin Pop
	@if [ -n "`git status --short`" ]; then \
1668 6438e259 Iustin Pop
	  echo "Git status is not clean!" 1>&2 ; \
1669 6438e259 Iustin Pop
	  git status --short; \
1670 6438e259 Iustin Pop
	  exit 1; \
1671 6438e259 Iustin Pop
	fi
1672 6438e259 Iustin Pop
1673 1d45f7a0 Iustin Pop
# we don't need the ancient implicit rules:
1674 1d45f7a0 Iustin Pop
%: %,v
1675 1d45f7a0 Iustin Pop
%: RCS/%,v
1676 1d45f7a0 Iustin Pop
%: RCS/%
1677 1d45f7a0 Iustin Pop
%: s.%
1678 1d45f7a0 Iustin Pop
%: SCCS/s.%
1679 1d45f7a0 Iustin Pop
1680 3baa809c Michael Hanselmann
-include ./Makefile.local
1681 3baa809c Michael Hanselmann
1682 e8230860 Michael Hanselmann
# vim: set noet :